#####################################################################
# ZEXEC_REAL_FST.pl
#
#  Useage : ZEXEC_REAL_FST.pl -t YYMMDDHHmm (JST)
#   YYMMDDHHmmꤷʤС߻Ǽ¹ԡ
#
#####################################################################

use Getopt::Long;
use Time::Local;
$Getopt::Long::ignorecase=undef;
GetOptions('t=s');

########  SETTING  #########
$TBLTAG="KANI";
$TBLFG="K"; 
############################

#######    ###################
if( $opt_t ne "" && length($opt_t)!=10 ){
   die "Usage ./ZEXEC_REAL_FST.pl -t YYMMDDHHmm\n YYMMDDHHmm:JST\n";
}elsif( length( $opt_t ) == 10 ){
    $jyear4=1*substr($opt_t,0,2)+2000;
    $jyear2=1*substr($opt_t,0,2);
    $jmonth =1*substr($opt_t,2,2);
    $jday =1*substr($opt_t,4,2);
    $jhour=1*substr($opt_t,6,2);
    $jmin=1*substr($opt_t,8,2);
    $YMDHM = sprintf("%02d%02d%02d%02d%02d", $jyear2,$jmonth,$jday,$jhour,$jmin); 
}else{
    $jst = time();
    ($jsec,$jmin,$jhour,$jday,$jmonth,$jyear)=localtime( $jst );
    $jyear4=$jyear+1900; $jyear2=$jyear4%100; $jmonth++;
    $YMDHM = sprintf("%02d%02d%02d%02d%02d", $jyear2,$jmonth,$jday,$jhour,$jmin);
}

########################################

$prm_file = "../exec_platform_mng/ZEXEC_REAL_FST_MNG.prm";
open (PRM,"<$prm_file");
  @dat = <PRM>;
close(PRM);

$TBLTAG_S = sprintf("<%s>",$TBLTAG);
$TBLTAG_E = sprintf("<\/%s>",$TBLTAG);

foreach $line ( @dat ) {
  @buf = ();
  chomp($line);
#  print "line=$line\n";
  if ( $line =~ /^$TBLTAG_E/ ) { last ; }
  if ( $line =~ /^$TBLTAG_S/ ) { next ; } 
  next if ($line =~ /^#/);
  @buf = split(/,/,"$line");
  if ( $buf[0] ne $TBLFG ) { next ; }
  $ANo = $buf[1];
  $WFNo = $buf[2];
  $AWFNo = sprintf("%s%s",$ANo,$WFNo);
  $AREA_NUM{$AWFNo} = $ANo;
  $WF_NUM{$AWFNo} = $WFNo;
  $TABLE{$AWFNo} = $buf[3];
#  print "$AREA_NUM{$AWFNo},$WF_NUM{$AWFNo},$TABLE{$AWFNo}\n";
}

#--------------------------------------------------------------------
# 1. make dataset
#--------------------------------------------------------------------
foreach $AW (keys %TABLE) {
  $cmd =sprintf("perl ./mk_dataset_realfst.pl %s %s %s -t %s",$TABLE{$AW},$AREA_NUM{$AW},$WF_NUM{$AW},$YMDHM);
  system($cmd);
}

#--------------------------------------------------------------------
# 2. make csv data
#--------------------------------------------------------------------
foreach $AW (keys %TABLE) {
  $cmd1 =sprintf("perl ./mk_csv_real.pl %s %s %s -t %s",$TABLE{$AW},$AREA_NUM{$AW},$WF_NUM{$AW},$YMDHM);
  system($cmd1);
  $cmd2 =sprintf("perl ./mk_csv_real_yetm.pl %s %s %s -t %s",$TABLE{$AW},$AREA_NUM{$AW},$WF_NUM{$AW},$YMDHM);
  system($cmd2);
}

#--------------------------------------------------------------------
# 3. make graph
#--------------------------------------------------------------------
foreach $AW (keys %TABLE) {
  $cmd1 =sprintf("perl ./mk_pic_real.pl %s %s %s",$TABLE{$AW},$AREA_NUM{$AW},$WF_NUM{$AW});
  system($cmd1);
  $cmd2 =sprintf("perl ./mk_pic_real_yetm.pl %s %s %s",$TABLE{$AW},$AREA_NUM{$AW},$WF_NUM{$AW});
  system($cmd2);
}

exit
