#! /usr/local/bin/perl
######################################################################
#
# name : Stat_v15.pm
#
# First edit date : 1999.04.21(Wed)
#       edit date : 1999.10.22(Fri)
# Last  edit date : 2004.06.24(Thu)
#
# now dir : locals69 : /data1/ataru1/lib_perl
#
# date : 2000.06.10(Sat)
# errorǡб
#
# 2004.08.05 I.Aoki
# 2004.09.21 I.Aoki
# 2004.09.24 I.Aoki ҥȥɲ
# 2004.11.08 I.Aoki ʿͤѹ
# 2004.11.18 I.Aoki 硦߽ɲ
# 2004.12.14 I.Aoki פɲ
#
# 2005.01.04 I.Aoki ҥȥv2ɲ
# 2005.02.06 I.Aoki ߽磲ɲ
# 2005.02.10 I.Aoki ץ饹ιסιɲ
# 2005.10.31 I.Aoki ưʿѽɲ
# 2006.01.12 I.Aoki ׻ɲáʬɲ(Stat_v13)
# 2006.08.11 I.Aoki v14 RMSEʬ(drmse,bias,sdbias,disp)
# 2006.08.14 I.Aoki ccf_maxزϡɲ
# 2006.08.15 I.Aoki emax_emin,eamaxʸκͤˤĤơɲ
# 2006.09.12 I.Aoki ҥȥv3ɲ
# 2006.09.19 I.Aoki stat3,stat5ɲ
#
# 2007.02.13 I.Aoki my bug
######################################################################
package Stat_v15;

#use Exporter;           # Exporter.pm
@ISA = qw(Exporter);

## ؿ
@EXPORT_OK = qw( mean bias stddev stderr rmse max min wd16 regline corr wdstat hist decsort incsort sum);


#
# ǡ
#
sub count {
  my @x = @_;
  my $n = ($#x+1)*0.5;

  $n;
}

################################################################################
#
# ʿ
#
# syn:
#   Stat::mean(@data);
#
# Last edit date : 2000.06.10(Sat)
#
sub mean {
  my @data = @_;
  my $d,$mean;
  my $err_val = -999.9;
  my $count; 

 if( $#data < 0 ){
   $mean = $err_val;
 } else {
   $mean = 0;
   $count= 0;
   foreach $d (@data){
     if ( $d > $err_val ) {
        $mean += $d;
        $count++; 
     }
   }
   if($count > 0){
     $mean = $mean/$count;
   }else{
     $mean = $err_val;
   }
 }
 return $mean;

}

#
# ʿѸ
#
sub _bias {
  my @x = @_;
  my $xx,$yy,$zz,@y,@z;
  my $n   = $#x+1;
  my $nb2 = $n/2;
  my $bias;
  my $err_val = -999.9;

  @y = splice @x,$nb2,$nb2;
  
  @z=();
  foreach $xx (@x){
    $yy = shift @y;
    $zz = $yy - $xx;
    if( $yy > $err_val && $xx > $err_val ){
      push(@z,$zz);
    }
  }

  $bias = mean(@z);
  $bias = $err_val if( $#z < 0 );

  ( $bias,@z );
}

################################################################################
#
# ʿѸ
#
# syn:
#   Stat::bias(@data);
#
sub bias {
  my @x = @_;
  my $bias;
  ( $bias ) = _bias(@x);

  $bias;
}


################################################################################
#
# ɸк ( Standard Deviation )
#
#
# Last edit date : 2004.08.05
#
sub stddev {
  my @x = @_;
  my @z;
  my @x2;
  my $xx;
  my $sum;
  my $mean;
  my $n;
  my $stddev;
  my $err_val = -999.9;
  $,=' ';

  foreach $xx (@x){
    if( $xx > $err_val && $xx > $err_val ){
      push(@z,$xx);
    }
  }

  $mean = mean(@z);
  my $n = $#z+1;

  foreach $xx ( @z ){
    push(@x2,($xx-$mean)*($xx-$mean));
  }

  foreach $xx ( @x2 ){
    $sum += $xx;
  }
  #printf "sum: $sum\n"; 

  if( $n != 0 ){
    $stddev = sqrt($sum/$n);
  } else {
    $stddev = $err_val;
  }
  return $stddev;
}



################################################################################
#
# ɸ ( Standard Error : SE )
#
#
# Last edit date : 2000.06.10(Sat)
#
sub stderr {
  my @x = @_;
  my @d,@d2,@ds;
  my $sum,$dd,$bias;
  my $se;
  my $err_val = -999.9;
  $,=' ';

  @d =();
  ( $bias , @d ) = _bias(@x);
  my $n = $#d+1;

  @d2=();
  foreach $dd ( @d ){
    push(@d2,($dd-$bias)*($dd-$bias));
  }

  @ds = sort @d2;

  $sum = 0;
  foreach $dd ( @ds ){
    $sum += $dd;
  }
# print "[se]  n=$n sum=[$sum]\n";

  if( $n != 0 ){
    $se = sqrt($sum/$n);
  } else {
    $se = $err_val;
  }
  return $se;
}

################################################################################
#
# ʿѸ ( Root Mean Square Error : RMSE )
#
#
# Last edit date : 2000.06.10(Sat)
#
sub rmse {
  my @x = @_;
  my @d,@d2,@ds;
  my $sum,$dd,$bias;
  my $rmse;
  my $err_val = -999.9;

  ( $bias , @d ) = _bias(@x);
  my $n = $#d+1;

  @d2=();
  foreach $dd ( @d ){
    push(@d2,($dd*$dd));
  }

  @ds = sort @d2;

  $sum = 0;
  foreach $dd ( @ds ){
    $sum += $dd;
  }
# print "[rmse] n=$n sum=[$sum]\n";

  if( $n != 0 ){
    $rmse = sqrt($sum/$n);
  } else {
    $rmse = $err_val;
  }

  return $rmse;
}

#
# ͡ʼΡ
#
sub _max ($$@){
  my $s = shift @_;
  my $e = shift @_;
  my @x = @_;
  my $err_val = -999.9;
  my $max=-999;

  my $i=0;
  foreach $d ( @x ){
    if( $i>=$s && $i<=$e ){
      if ( $d < -900 ) {
         $max = $err_val;
         last;
      }
      if( $err_val <= $d ){
         #$max = $d  if( $d > $max );
         if ( $d > $max ){
            $max   = $d;
            $max_i = $i;
         } 
      }
    }
    $i++;
  }

  ($max,$max_i);
}

################################################################################
#
#  (wrapper)
#
# syn:
#   Stat::max(@data);
#   Stat::max(@data,':',$s,$e);
#
sub max {
  my @x  = @_;
  my @xx = @x;
  my $s  = 0;
  my $e  = $#x;

  if( $x[$e-2] =~ /:/ ){
     @xx = splice(@x,0,($e-2));
     $s = $x[1];
     $e = $x[2];
#    print "͡ʬ  : [$s,$e]\n";
#    print "xx =[@xx]\n";
#    print "x  =[@x ]\n";
  } else {
#    print "͡ʤ٤ơ: [$s,$e]\n";
  }

  ( $max,$max_i ) = _max($s,$e,@xx);
  ( $max,$max_i );
}

#
# Ǿ͡ʼΡ
#
sub _min ($$@){
  my $s = shift @_;
  my $e = shift @_;
  my @x = @_;
  my $err_val = -999.9;
  my $err_sep = -900.0;
  my $min     = 999;
  my $min_i   = 0;
  my $i=0;
  foreach $d ( @x ){
    if( $i>=$s && $i<=$e ){
      if ( $d < -900 ) {
         $min = $err_val;
         last;
      }
      if( $err_sep <= $d ){
#       $min = $d  if( $d < $min );
        if ( $d < $min ){
           $min   = $d;
           $min_i = $i;
        }
    }
    }
    $i++;
  }

  $min = $err_val if( $min == 999 );
  return ( $min, $min_i );
}

################################################################################
#
# Ǿ (wrapper)
#
# syn:
#   Stat::min(@data);
#   Stat::min(@data,':',$s,$e);
#
sub min {
  my @x  = @_;
  my @xx = @x;
  my $s  = 0;
  my $e  = $#x;
  my $min_i = 0;

  if( $x[$e-2] =~ /:/ ){
     @xx = splice(@x,0,($e-2));
     $s = $x[1];
     $e = $x[2];
#    print "Ǿ͡ʬ  : [$s,$e]\n";
#    print "xx =[@xx]\n";
#    print "x  =[@x ]\n";
  } else {
#    print "Ǿ͡ʤ٤ơ: [$s,$e]\n";
  }

  ( $min, $min_i ) = _min($s,$e,@xx);
  ( $min, $min_i );
}

################################################################################
#
# Ϥʣ̡
#
# syn:
#   ($o,$x,$n) = Stat::wd8(@obs,@loc);
#
sub wd8 {
  my @x = @_;
  my @diff;
  my $o,$x,$n;
  ( $o,$x,$n,@diff ) = _wd(22.5,@x);

  ( $o,$x,$n );
}

################################################################################
#
# Ϥʣ)
#
# syn:
#   ($o,$x,$n) = Stat::wd4(@obs,@loc);
#
sub wd4 {
  my @x = @_;
  my @diff;
  my $o,$x,$n;
  ( $o,$x,$n,@diff ) = _wd(45.0,@x);

  ( $o,$x,$n );
}

sub _wd {
  my $dir = shift @_;
  my @x   = @_;
  my $n   = $#x+1;
  my $nb2 = $n/2;
  my $xx,$yy,$zz,@y;
  @y = splice @x,$nb2,$nb2;

  my @z = ();
  my $o = 0;
  my $x = 0;
  foreach $xx (@x){
    $yy = shift @y;
    $zz = abs($yy-$xx);
    $zz = 360 - $zz if( $zz >= (360-$dir) );
    $o++ if( $zz <= $dir );
    $x++ if( $zz >  $dir );
    push(@z,$zz);
  }
  ( $o,$x,$nb2,@z );
}

################################################################################
#
# ľη (y=bx+a)
#
# syn:
#   Stat::regline(@x,@y);
#
# Last edit date : 2002.04.22(Mon)
#
sub regline{
  my @x = @_;
  my @y,@z;
  my $n   = $#x+1;
  my $nb2 = $n/2;
  my $err_val = -999.9;

  @y = splice @x,$nb2,$nb2;

  my $xb=0,$yb=0,$xy=0,$x2=0;
  my $nn=0;
  foreach my $i (0..$#x){
    if( $x[$i] > $err_val && $y[$i] > $err_val ){
      $xb += $x[$i];
      $yb += $y[$i];
      $x2 += $x[$i]*$x[$i];
      $xy += $x[$i]*$y[$i];
      $nn++;
    }
  }
  $xb /= $nn;
  $yb /= $nn;

# print "x:@x \n";
# print "y:@y \n";
# print "############# NN=$nn \n";

  my $a,$b=0;
  if( ($x2 - $nn*$xb*$xb) == 0 ){ $b=1;$a=0;}
  else{
   $b = ( $xy - $nn*$xb*$yb )/( $x2 - $nn*$xb*$xb );
   $a = $yb - $b*$xb;
  }

  ($a,$b);
}

################################################################################
#
# ط
#
# syn:
#   Stat::corr(@x,@y);
#
# Last edit date : 2002.07.13(Sat)
#
sub corr{
  my @xx = @_;
  my @yy,@z;
  my $n   = $#xx+1;
  my $nb2 = $n/2;
  my $err_val = -999.9;
  my @x=(),@y=();

  @yy = splice @xx,$nb2,$nb2;

  foreach $i ( 0..$#xx ){
    if( $xx[$i] > $err_val && $yy[$i] > $err_val ){ 
      push(@x,$xx[$i]);
      push(@y,$yy[$i]);
# printf "$i : $xx[$i] $yy[$i] \n";
    }
  }
# print "x=$#x xx=$#xx y=$#y yy=$#yy \n";

  my $xm,$ym;
  $xm = mean(@x);
  $ym = mean(@y);

  my $xy=0,$x2=0,$y2=0;
  foreach $i ( 0..$#x ){
    $xy += ( $x[$i]-$xm )*( $y[$i]-$ym ) ;
    $x2 += ( $x[$i]-$xm )*( $x[$i]-$xm ) ;
    $y2 += ( $y[$i]-$ym )*( $y[$i]-$ym ) ;
# print "$i : $xy $x2 $y2 : $x[$i] $xm $y[$i] $ym \n";
  }

  my $corr = 0;
  if($x2 == 0 or $y2 == 0){ $corr = -999.9; }
  else{ $corr = $xy /( sqrt($x2)*sqrt($y2) ); }

  $corr;
}

################################################################################
#
# ٸ
#
# syn:
#   Stat::wdstat(@x,@y);
#
# Last edit date : 2002.07.13(Sat)
#
sub wdstat{
  my @xx = @_;
  my @yy,@z;
  my $n   = $#xx+1;
  my $nb2 = $n/2;
  my $HOLE = 360.0;
  my $HARF = 180.0;
  my $err_val = -999.9;
  my @x=(),@y=();
  @yy = splice @xx,$nb2,$nb2;

  foreach $i ( 0..$#xx ){
    if( $xx[$i] > $err_val && $yy[$i] > $err_val ){ 
      push(@x,$xx[$i]);
      push(@y,$yy[$i]);
      #printf "$i : $xx[$i] $yy[$i] \n";
    }
  }

  my $xm,$ym,$g;
  my $bias_wd,$rmse_wd,$mean_wd1,$mean_wd2;
  my $WD01,$WD00,$DWD_O;
  my @DWD=(),@DWD2=();

  foreach $g ( 0..$#x ){
      $WD01 = $x[$g]; $WD00 = $y[$g];
     foreach (1..10){
      if    ( $WD01 > $HOLE){
        $WD01 = $WD01 - $HOLE;
      }elsif( $WD01 <= 0.   ){
        $WD01 = $WD01 + $HOLE;
      }
      if    ( $WD00 > $HOLE ){
        $WD00 = $WD01 - $HOLE;
      }elsif( $WD00 <= 0.    ){
        $WD00 = $WD00 + $HOLE;
      }
     }

      #-------------------------
      if( $WD01 <= $HARF ){
        if( $WD00 <= $HARF ){
          $DWD_O = $WD01-$WD00;
        }else{
          if( $WD01 + $HARF <= $WD00 ){
            $DWD_O = $WD01 - ( $WD00 - $HOLE );
          }
          if( $WD01 + $HARF <= $WD00 ){
            $DWD_O = $WD01 - ( $WD00 - $HOLE );
          }else{
            $DWD_O = $WD01 - $WD00;
          }
        }
      }else{
        if( $WD01 <= $WD00 ){
          $DWD_O = $WD01 - $WD00;
        }else{
          if( $WD01 - $HARF <= $WD00 ){
            $DWD_O = $WD01 - $WD00;
          }else{
            $DWD_O = $WD01 - ( $WD00 + $HOLE );
          }
        }
      }
       #printf "$g,$DWD_O\n";
      #-------------------------
     push(@DWD,$DWD_O);
     push(@DWD2,$DWD_O*$DWD_O);
  }

  $mean_wd1 = mean(@DWD);
  if(abs($mean_wd1) > 900){$bias_wd = -999.9;}
  else                    {$bias_wd = (-1)*$mean_wd1;}
  $mean_wd2 = mean(@DWD2);
  if($mean_wd2 < 0){$rmse_wd = -999.9;}
  else             {$rmse_wd = sqrt($mean_wd2);}

 ($bias_wd,$rmse_wd);
}

################################################################################
#
# ҥȥ(ٿ) "lbin <  <= hbin"
# -------------------------
#   -1     0     1     2
# -------------------------
# < -1 =<
#       <  0 =<
#             <  1 =<
# syn:
#   Stat::histd($min,$max,$bin,@DATA);
#
# Last edit date : 2004.09.24
#
sub histd{
  my $min = $_[0];
  my $max = $_[1];
  my $bin = $_[2];
  shift(@_);shift(@_);shift(@_);
  my @x = @_;
  my @z = ();
  my $err_val = -999.9;
  my @HISTD=();

  #-- error check --#
  foreach my $xx (@x){
    if( $xx > $err_val){
      push(@z,$xx);
    }
  }
 
  my $nbin = ($max-$min)/$bin;
  my $bin2 = $bin/2;

  # initialization #
  foreach $nb (0..$nbin){  $deg{$nb}=0; }
  
  foreach my $zz (@z){
    foreach $nb (0..$nbin){
      $lbin = $min+$bin*$nb - $bin2; 
      $hbin = $min+$bin*$nb + $bin2; 
      #printf "$zz, $nb, $lbin,$hbin\n";
      if    ($nb == 0 ){
        if($zz <= $hbin)                { $deg{$nb}++;}
      }elsif($nb == $nbin){
        if($zz >  $lbin)                { $deg{$nb}++;}
      }else{
        if($zz > $lbin and $zz <= $hbin){ $deg{$nb}++; }
      }    
    }
  }
  
    foreach $nb (0..$nbin){
      #printf "%4d,%6d\n",$min+$bin*$nb,$deg{$nb};
      push(@HISTD,$deg{$nb});
    }

 return (@HISTD);
}

################################################################################
#
# ҥȥ(ٿ) Version 2, "lbin <  <= hbin"
# -------------------------
#   -1     0     1     2
# -------------------------
#    < -1 =<
#          <  1 =<
# syn:
#   Stat::histd($min,$max,$bin,@DATA);
#
# Last edit date : 2005.01.04
#
sub histd_v2{
  my $min = $_[0];
  my $max = $_[1];
  my $bin = $_[2];
  shift(@_);shift(@_);shift(@_);
  my @x = @_;
  my @z = ();
  my $err_val = -999.9;
  my @HISTD=();

  #-- error check --#
  foreach my $xx (@x){
    if( $xx > $err_val){
      push(@z,$xx);
    }
  }
 
  my $nbin = ($max-$min)/$bin;
  my $bin2 = $bin;

  # initialization #
  foreach $nb (1..$nbin){  $deg{$nb}=0; }
  
  foreach my $zz (@z){
    foreach $nb (1..$nbin){
      $lbin = $min+$bin*$nb - $bin2; 
      $hbin = $min+$bin*$nb; 
      #printf "$zz, $nb, $lbin,$hbin\n";
      if    ($nb == 1 ){
        if($zz <= $hbin)                { $deg{$nb}++;}
      }elsif($nb == $nbin){
        if($zz >  $lbin)                { $deg{$nb}++;}
      }else{
        if($zz > $lbin and $zz <= $hbin){ $deg{$nb}++;}
      }
    }
  }
  
    foreach $nb (1..$nbin){
      #printf "%4d,%6d\n",$min+$bin*$nb,$deg{$nb};
      push(@HISTD,$deg{$nb});
    }

 return (@HISTD);
}

################################################################################
#
# ҥȥ(ѡ) "lbin <  <= hbin"
#
# syn:
#   Stat::histp($min,$max,$bin,@DATA);
#
# Last edit date : 2004.09.24
#
sub histp{
  my $min = $_[0];
  my $max = $_[1];
  my $bin = $_[2];
  shift(@_);shift(@_);shift(@_);
  my @x = @_;
  my @z = ();
  my $err_val = -999.9;
  my @HISTP = ();

  #-- error check --#
  foreach my $xx (@x){
    if( $xx > $err_val){
      push(@z,$xx);
    }
  }
 
  my $nbin = ($max-$min)/$bin;
  my $bin2 = $bin/2;

  # initialization #
  foreach $nb (0..$nbin){  $deg{$nb}=0; }
  
  foreach my $zz (@z){
    foreach $nb (0..$nbin){
      $lbin = $min+$bin*$nb - $bin2; 
      $hbin = $min+$bin*$nb + $bin2; 
      #printf "$zz, $nb, $lbin,$hbin\n";
      if    ($nb == 0 ){
        if($zz <= $hbin)                { $deg{$nb}++;}
      }elsif($nb == $nbin){
        if($zz >  $lbin)                { $deg{$nb}++;}
      }else{
        if($zz > $lbin and $zz <= $hbin){ $deg{$nb}++; }
      }    
    }
  }
 
    my $size = scalar(@z); 
 
    foreach $nb (0..$nbin){
      if($size == 0){
        push(@HISTP,-999.9);
      }else{
        $histp=$deg{$nb}/$size;
        #printf "%4d,%7.4f\n",$min+$bin*$nb,$histp;
        push(@HISTP,$histp);
      }
    }

 return (@HISTP);
}

################################################################################
#
# ҥȥ(ѡ) Version 2,"lbin <  <= hbin"
#
# syn:
#   Stat::histp_v2($min,$max,$bin,@DATA);
#
# Last edit date : 2005.01.04
#
sub histp_v2{
  my $min = $_[0];
  my $max = $_[1];
  my $bin = $_[2];
  shift(@_);shift(@_);shift(@_);
  my @x = @_;
  my @z = ();
  my $err_val = -999.9;
  my @HISTP=();

  #-- error check --#
  foreach my $xx (@x){
    if( $xx > $err_val){
      push(@z,$xx);
    }
  }
 
  my $nbin = ($max-$min)/$bin;
  my $bin2 = $bin;

  # initialization #
  foreach $nb (1..$nbin){  $deg{$nb}=0; }
  
  foreach my $zz (@z){
    foreach $nb (1..$nbin){
      $lbin = $min+$bin*$nb - $bin2; 
      $hbin = $min+$bin*$nb; 
      #printf "$zz, $nb, $lbin,$hbin\n";
      if    ($nb == 1 ){
        if($zz <= $hbin)                { $deg{$nb}++;}
      }elsif($nb == $nbin){
        if($zz >  $lbin)                { $deg{$nb}++;}
      }else{
        if($zz > $lbin and $zz <= $hbin){ $deg{$nb}++; }
      }    
    }
  }
 
    my $size = scalar(@z); 
 
    foreach $nb (1..$nbin){
      if($size == 0){
        push(@HISTP,-999.9);
      }else{
        $histp=$deg{$nb}/$size;
        #printf "%4d,%7.4f\n",$min+$bin*$nb,$histp;
        push(@HISTP,$histp);
      }
    }

 return (@HISTP);
}

################################################################################
#
# ҥȥ(label)
#
# syn:
#   Stat::histl($min,$max,$bin,@DATA);
#
# Last edit date : 2004.09.24
#
sub histl{
  my $min = $_[0];
  my $max = $_[1];
  my $bin = $_[2];
  my @HISTL = ();

  my $nbin = ($max-$min)/$bin;
  
    foreach $nb (0..$nbin){
      push(@HISTL,$min+$bin*$nb);
    }

 return (@HISTL);
}

################################################################################
#
# ҥȥ(label) Version 2
#
# syn:
#   Stat::histli_v2($min,$max,$bin,@DATA);
#
# Last edit date : 2005.01.04
#
sub histl_v2{
  my $min = $_[0];
  my $max = $_[1];
  my $bin = $_[2];
  my @HISTL = ();

  my $nbin = ($max-$min)/$bin;
  
    foreach $nb (0..$nbin){
      if($min+$bin*$nb != 0){   #" 0Ǥʤʬ٥Ȥ
        push(@HISTL,$min+$bin*$nb);
      }
    }

 return (@HISTL);
}

################################################################################
#
# 
#
# syn:
#   Stat::incsort(@DATA);
#
# Last edit date : 2004.11.18
#
sub incsort{
  my @DATA=@_;
  my $size;
  
  $size = scalar(@DATA);
    for($g=0;$g<$size;$g++){
     for($k=$g+1;$k<$size;$k++){
      $data1 = $DATA[$g]; $data2 = $DATA[$k];
      if($data1 > $data2){
        splice(@DATA,$g,1,$data2);  splice(@DATA,$k,1,$data1);
      }
     }  #" $k
    } #" $g
 return (@DATA);
}

################################################################################
#
# ߽
#
# syn:
#   Stat::decsort(@DATA);
#
# Last edit date : 2004.11.18
#
sub decsort{
  my @DATA=@_;
  my $size;
  
  $size = scalar(@DATA);
    for($g=0;$g<$size;$g++){
     for($k=$g+1;$k<$size;$k++){
      $data1 = $DATA[$g]; $data2 = $DATA[$k];
      if($data1 < $data2){
        splice(@DATA,$g,1,$data2);  splice(@DATA,$k,1,$data1);
      }
     }  #" $k
    } #" $g
 return (@DATA);
}

################################################################################
# 
#
#   Stat::sum(@DATA);
#
# Last edit date : 2004.12.14
################################################################################
sub sum{
  my @x=@_;
  my @z = ();
  my $size;
  my $sum;
  my $err_val = -999.0;
  
  #-- error check --#
  foreach my $xx (@x){
    if( $xx > $err_val){
      push(@z,$xx);
    }
  }

  $sum = 0;
  $size = scalar(@z);
    for($g=0;$g<$size;$g++){
      $sum += $z[$g]; 
    } #" $g
 return ($sum);
}


################################################################################
#
# ߽2
#
# syn:
#   Stat::decsort_v2(@DATA);
#
# Last edit date : 2004.11.18
#
sub decsort_v2{
  my @DATA1 = @_;
  my @DATA2;
  my $n   = $#DATA1+1;
  my $nb2 = $n/2;
  my $size;

  @DATA2 = splice @DATA1,$nb2,$nb2;

  # SIZE CHECK #
  if($#DATA1 != $#DATA2){printf "error!!\n";exit;}
  ##############

  $size = scalar(@DATA1);
    for($g=0;$g<$size;$g++){
     for($k=$g+1;$k<$size;$k++){
      $data11 = $DATA1[$g]; $data12 = $DATA1[$k];
      $data21 = $DATA2[$g]; $data22 = $DATA2[$k];
      if($data11 < $data12){
        splice(@DATA1,$g,1,$data12);  splice(@DATA1,$k,1,$data11);
        splice(@DATA2,$g,1,$data22);  splice(@DATA2,$k,1,$data21);
      }
     }  #" $k
    } #" $g
 return (@DATA1,@DATA2);
}

################################################################################
# ̤Τιסο򻻽н
#
#   Stat::sumh(@DATA);
#
# Last edit date : 2005.02.10
################################################################################
sub sumh{
  my @x=@_;
  my @z = ();
  my $size;
  my $sump,$nump;
  my $err_val = -999.0;
  
  #-- error check --#
  foreach my $xx (@x){
    if( $xx > $err_val){ push(@z,$xx); }
  }

  $sump = 0; $nump = 0;
  $size = scalar(@z);
    for($g=0;$g<$size;$g++){
      if($z[$g] >= 0){ $sump += $z[$g]; $nump++; }
      elsif($z[$g] < 0){ $summ += $z[$g]; $numm++; }
    } #" $g
 return ($sump,$summ,$nump,$numm);
}

################################################################################
#  ưʿѤ»
#   Ϣ³ĤΥǡǡ10Ұʾưä餷饨顼Ȥ
#   106֤ΰưʿѤ -> (7,8,9,[10],11,12)
#
#   Stat::mave(@DATA,$num); 
#      numϰưʿѤȾ(1֥ǡʤ$num=3Ǥ6֤ΰưʿ)
#
# Last edit date : 2005.10.31
################################################################################
sub mave{
  my @x=@_;
  my @xx=();
  my $num = pop(@x);
  my $err_val = -999.0;
  my $ave,$sum,$num,$cnt,$th,$sigma,$rate,$flag,$a;
  my @OUT=();

  $size = scalar(@x);

  # ERR -------------------------------------------
  $rate = 10;
  $sigma = stddev(@x);
  $th = $sigma*$rate;

  printf "SIGMA: $sigma\n";

  push(@xx,$x[0]);push(@xx,$x[1]);
  for($g=2;$g<$size-2;$g++){
   if( $x[$g] > $err_val ){ 
    $flag = 0;
    foreach $a (1..2){
     if( $x[$g-$a] > $err_val and abs($x[$g-$a] - $x[$g]) >= $th ){
      printf "[ ERR(line=$g):  %f >= %f\n",$x[$g-$a]-$x[$g],$th;
      $flag = 1;last;
     }
    } #" $a
    if($flag == 1){ $out = $err_val; }
    else          { $out = $x[$g];   }
    push(@xx,$out);
   }else{
    push(@xx,$err_val);
   }
  #if($flag == 1){printf "G $g: %f\n",$xx[$g];}
  } #" $g
  push(@xx,$x[$size-2]);push(@xx,$x[$size-1]);
  #----------------------------------------------------

  for($g=0;$g<$num;$g++){ push(@OUT,$xx[$g]); }
  for($g=$num;$g<($size-$num-1);$g++){

     $cnt = 0;$sum = 0;
     foreach $n (1..($num*2)) {
       $nn = $g + $n - ($num+1);
       $data = $xx[$nn];
       if($data > $err_val){ $sum += $data; $cnt++; }
     } #" $n

     if($cnt == 0){ $ave = $data; }
     else         { $ave = $sum/$cnt; }

    push(@OUT,$ave);
  } #" $g
  for($g=($size-$num-1);$g<$size;$g++){ push(@OUT,$xx[$g]); }
 return (@OUT);
}



################################################################################
# ׻
#			ͽ¬(B)
#	---------------------------------
#		  Ͱʾ  ̤
#	---------------------------------
#	Ͱʾ     c1        c2    
#  ¬ ---------------------------------
#  (A)  ̤     c3        c4    
#	---------------------------------
#         th  ()
#  score1 hit (ŪΨ)
#  score1 mino(ƨΨ)
#  score1 kara(Ψ)
#  score1 hoso(ªΨ)
#  score1 itti(Ψ)
#  score2 ss  (åȥ(Critical Success Index))
#  score2 bs  (Х:¶ͽ¬٤)
#
#  ̤ξΥ
#  score1r hit (ŪΨ)
#  score1r mino(ƨΨ)
#  score1r kara(Ψ)
#  score1r hoso(ªΨ)
#  score1r itti(Ψ)
#
# 2006.01.11
################################################################################
sub score1 {
    my @ORI = @_;
    my $th = shift(@ORI);
    my $len = ($#ORI+1)/2;
    my @A = (); #" ¬
    my @B = (); #" ͽ¬
    my $hit,$mino,$kara,$hoso,$itti,$g,$n;
    my $c1=0;$c2=0;$c3=0;$c4=0;
    @A = splice @ORI,0,$len;
    @B = @ORI;
    if($#A != $#B){printf " ERR!! $#A != $#B \n";exit;}

   foreach $g (0..$#A){
    $a = $A[$g];$b = $B[$g];
     if($a >= $th){
       if($b >= $th){ $c1++; }
       else         { $c2++; }         
     }else{
       if($b >= $th){ $c3++; }
       else         { $c4++; }         
     } 
   }
  $n = $c1+$c2+$c3+$c4;
  if($n != 0){ $hit  = ($c1+$c4)/($n);
               $mino = ($c2)/($n);
               $kara = ($c3)/($n);
  }else      { $hit  = -999.9;
               $mino = -999.9;
               $kara = -999.9;
  }
  if(($c1+$c2) != 0){ $hoso = ($c1)/($c1+$c2);}
  else              { $hoso = -999.9;}
  if(($c1+$c3) != 0){ $itti = ($c1)/($c1+$c3);}
  else              { $itti = -999.9;}
($hit,$mino,$kara,$hoso,$itti);
}
sub score2 {
    my @ORI = @_;
    my $th = shift(@ORI);
    my $len = ($#ORI+1)/2;
    my @A = (); #" ¬
    my @B = (); #" ͽ¬
    my $ss,$bs;
    my $c1=0;$c2=0;$c3=0;$c4=0;
    @A = splice @ORI,0,$len;
    @B = @ORI;
    if($#A != $#B){printf " ERR!! $#A != $#B \n";exit;}

   foreach $g (0..$#A){
    $a = $A[$g];$b = $B[$g];
     if($a >= $th){
       if($b >= $th){ $c1++; }
       else         { $c2++; }         
     }else{
       if($b >= $th){ $c3++; }
       else         { $c4++; }         
     } 
   }
  if(($c1+$c2+$c3) != 0){ $ss = ($c1)/($c1+$c2+$c3);}
  else                  { $ss = -999.9;}
  if(($c1+$c2) != 0)    { $bs = ($c1+$c3)/($c1+$c2);}  #" ͽ¬/¬
  else                  { $bs = -999.9;}
($ss,$bs);
}
sub score1r {
    my @ORI = @_;
    my $th = shift(@ORI);
    my $len = ($#ORI+1)/2;
    my @A = (); #" ¬
    my @B = (); #" ͽ¬
    my $hit,$mino,$kara,$hoso,$itti,$g,$n;
    my $c1=0;$c2=0;$c3=0;$c4=0;
    @A = splice @ORI,0,$len;
    @B = @ORI;
    if($#A != $#B){printf " ERR!! $#A != $#B \n";exit;}

   foreach $g (0..$#A){
    $a = $A[$g];$b = $B[$g];
     if($a < $th){
       if($b < $th){ $c1++; }
       else        { $c2++; }         
     }else{
       if($b < $th){ $c3++; }
       else        { $c4++; }         
     } 
   }
  $n = $c1+$c2+$c3+$c4;
  if($n != 0){ $hit  = ($c1+$c4)/($n);
               $mino = ($c2)/($n);
               $kara = ($c3)/($n);
  }else      { $hit  = -999.9;
               $mino = -999.9;
               $kara = -999.9;
  }
  if(($c1+$c2) != 0){ $hoso = ($c1)/($c1+$c2);}
  else              { $hoso = -999.9;}
  if(($c1+$c3) != 0){ $itti = ($c1)/($c1+$c3);}
  else              { $itti = -999.9;}
($hit,$mino,$kara,$hoso,$itti);
}


################################################################################
# ʬ
# 
# 2006.01.11
################################################################################
sub dfreq360{
    my @ORI = @_;
    my $type = shift(@ORI); #" type : d,p,l,a
    my $dnum  = shift(@ORI); #" type : 8,12,32 
    my $len = ($#ORI+1)/2; 
    my @A,@B,@AA,@BB,@DD,@DP,@LABEL,@MEAN,@DATA,@OUT,@LL;
    my $d,$g,$cnt,$scnt,$dd,$dp,$mean,$hd,$ld,$lable;
    my $div = 360/$dnum;

    @A=();@B=();@AA=();@BB=();@DD=();@DP=();@LABEL=();@MEAN=();@DATA=();@OUT=();@LL=();

#    printf "Parameter : $type,$dnum,$len\n";

    if($type eq "a"){
     @A = splice @ORI,0,$len;@B = @ORI;
     if($#A != $#B){printf " ERR!! $#A != $#B \n";exit;}
    }else{
     @A = @ORI;
    }

    if    ($dnum ==  4){
     @LABEL = ('E','S','W','N');
    }elsif($dnum ==  8){
     @LABEL = ('NE','E','SE','S','SW','W','NW','N');
    }elsif($dnum == 16){
     @LABEL = ('NNE','NE','ENE','E','ESE','SE','SSE','S','SSW','SW','WSW','W','WNW','NW','NNW','N');
    }elsif($dnum == 32){
     @LABEL = ('','NNE','','NE','','ENE','','E','','ESE','','SE','','SSE','',
               'S','','SSW','','SW','','WSW','','W','','WNW','','NW','','NNW','','N');
    }

  if($type eq "l"){

    foreach $d ($dnum,1..($dnum-1)){
      $label = $LABEL[$d-1];     push(@LL,$label);
    }

  }else{

    foreach $d (1..$dnum){ @{$DATA->{$d}}=();$cnt{$d}=0; }

    # err check #
    foreach $g (0..$#A){
      if($A[$g] > -999.0){ push(@AA,$A[$g]);push(@BB,$B[$g]);}
    }

    foreach $g (0..$#AA){
    foreach $d (1..$dnum){
      if($d != $dnum){
        $ld = $d*$div - $div/2;
        $hd = $d*$div + $div/2;
        if($AA[$g] >= $ld and $AA[$g] < $hd){ $cnt{$d}++; push(@{$DATA->{$d}},$BB[$g]);}
      }else{
        $ld = $d*$div - $div/2;
        $hd = $div/2;
        if($AA[$g] >= $ld or $AA[$g] < $hd){ $cnt{$d}++; push(@{$DATA->{$d}},$BB[$g]);}
      }
    } #" $d
    } #" $g
    $scnt=0;
    foreach $d (1..$dnum){ $scnt += $cnt{$d}; }
    foreach $d ($dnum,1..($dnum-1)){
      $dd    = $cnt{$d};       push(@DD,$dd);
      $dp    = $cnt{$d}/$scnt; push(@DP,$dp);
      $mean = mean(@{$DATA->{$d}});push(@MEAN,$mean)
    }
  }

if   ($type eq "d"){ @OUT = @DD; }
elsif($type eq "p"){ @OUT = @DP; }
elsif($type eq "l"){ @OUT = @LL; }
elsif($type eq "a"){ @OUT = @MEAN; }

(@OUT);
}

################################################################################
#
# ʿѸ ( Root Mean Square Error : RMSE ) ʬ
#
# -> RMSE,BIAS,CORR,SDBIAS,DISP,ERROR_STDDEV
#
# Last edit date : 2006.08.11
#
sub drmse {
  my @x = @_;
  my @d,@d2,@ds;
  my $n   = $#x+1;
  my $nb2 = $n/2;
  my @y;
  my $rmse,$bias,$sdbias,$disp,$corr;
  my $stdev_x,$stdev_y;
  my $err_val = -999.9;
  my @e,$e1,$g1;

  ( $bias ) = bias(@x);
  ( $rmse ) = rmse(@x);

  @y = splice @x,$nb2,$nb2;

  foreach $g1 (0..$#x){
    $x1 = $x[$g1];
    $y1 = $y[$g1];
    if($x1 < -900 or $y1 < -900){ $e1 = $err_val;}
    else                        { $e1 = $y1 - $x1;}
    push(@e,$e1);
  }

 
  ( $stdev_x  ) = stddev(@x);
  ( $stdev_y  ) = stddev(@y);
  ( $stdev_e  ) = stddev(@e);
  ( $corr ) = corr(@x,@y);

  if($stdev_y < -900 or $stdev_x < -900){
   $sdbias =  $err_val;
   $disp   =  $err_val;
  }else{
   $sdbias = $stdev_y - $stdev_x;
   $disp   = sqrt(2*$stdev_y * $stdev_x * (1-$corr));
  }

 return ($rmse,$bias,$corr,$sdbias,$disp,$stdev_e);
 #return ($rmse,$bias,$corr,$sdbias,$disp,$stdev_x,$stdev_y,$corr);
}

################################################################################
#
# زϡؤλ֡ط֤
#
# <- ($pt,@OBS,@FCS)
# -> (mnum,mcorr) mnum > 0 : ͽ¬ʹԡmnum < 0 ͽ¬ٱ 
#
# Last edit date : 2006.08.14
#
sub ccf_max{
  my $pt = shift(@_);
  my @xx = @_;
  my @yy;
  my $n   = $#xx+1;
  my $nb2 = $n/2;
  my $err_val = -999.9;
  my @x=(),@y=();
  my $mnum,$mcorr;
  my @px,@py,@CORR,$acnt;

  @yy = splice @xx,$nb2,$nb2;

  $mcorr = $err_val;
  foreach $p ( -$pt .. $pt ){
    @px=();@py=();$acnt=0;
    if($p < 0){                  #" yٱξ  
      $sx=0;      $ex=$#xx-abs($p); #" absŪ
      $sy=abs($p);$ey=$#xx;
    }else{                       #" yʹԤξ
      $sx=abs($p);$ex=$#xx; 
      $sy=0;      $ey=$#xx-abs($p);
    }
    foreach $i ( $sx..$ex ){ push(@px,$xx[$i]); }
    foreach $i ( $sy..$ey ){ push(@py,$yy[$i]); }
    foreach $i (0..$#px){
      if($px[$i] > -900 and $py[$i] > -900){ $acnt++; }
    }
    if($acnt < ($#px+1)/4){  #" ǡ3/4ʾ夬顼äˤؤ-999.9
      $corr = -999.9;
    }else{
      $corr = corr(@px,@py);
    }
#    if($p == 21){
#      foreach $i (0..$#px){
#       printf "$i, $px[$i],$py[$i]\n";
#      }
#    }
    #printf "%d,%d\n",$#px,$#py;
    #printf "%5d,%7.3f,%d/%d,%7.2f\n",$p,$corr,$acnt,$#px+1,$acnt/($#px+1);
    push(@CORR,$corr);
    if($mcorr < $corr){
      $mcorr = $corr;
      $mnum  = $p;
    }
  } #" $p
 return ($mnum,$mcorr);
}

################################################################################
#
# زϡؤλ֡ط֤
#
# <- ($p_pt,$m_pt,@OBS,@FCS)
# -> (mnum,mcorr) mnum > 0 : ͽ¬ʹԡmnum < 0 ͽ¬ٱ
#
# Last edit date : 2006.09.15 ץ饹ޥʥͤʬ
#
sub ccf_max2{
  my $p_pt = shift(@_); #" ͽ¬ʤ
  my $m_pt = shift(@_); #" ͽ¬٤餹
  my @xx = @_;
  my @yy;
  my $n   = $#xx+1;
  my $nb2 = $n/2;
  my $err_val = -999.9;
  my @x=(),@y=();
  my $mnum,$mcorr;
  my @px,@py,@CORR,$acnt;

  @yy = splice @xx,$nb2,$nb2;

  $mcorr = $err_val;
  foreach $p ( -$m_pt .. $p_pt ){
    @px=();@py=();$acnt=0;
    if($p < 0){                  #" yٱξ
      $sx=0;      $ex=$#xx-abs($p); #" absŪ
      $sy=abs($p);$ey=$#xx;
    }else{                       #" yʹԤξ
      $sx=abs($p);$ex=$#xx;
      $sy=0;      $ey=$#xx-abs($p);
    }
    foreach $i ( $sx..$ex ){ push(@px,$xx[$i]); }
    foreach $i ( $sy..$ey ){ push(@py,$yy[$i]); }
    foreach $i (0..$#px){
      if($px[$i] > -900 and $py[$i] > -900){ $acnt++; }
    }
    #if($acnt < ($#px+1)/4){  #" ǡ3/4ʾ夬顼äˤؤ-999.9
    if($acnt < $ucnt/2){  #" ǡ3/4ʾ夬顼äˤؤ-999.9
      $corr = -999.9;
    }else{
      $corr = corr(@px,@py);
    }

  #printf "%02d,%7.3f, %02d\n",$p,$corr,$acnt;


#    if($p == 21){
#      foreach $i (0..$#px){
#       printf "$i, $px[$i],$py[$i]\n";
#      }
#    }
    #printf "%d,%d\n",$#px,$#py;
    #printf "%5d,%7.3f,%d/%d,%7.2f\n",$p,$corr,$acnt,$#px+1,$acnt/($#px+1);
    push(@CORR,$corr);
    if($mcorr < $corr){
      $mcorr = $corr;
      $mnum  = $p;
    }
  } #" $p
 return ($mnum,$mcorr);
}

################################################################################
# ʿѸ,ʿ,ط 
#
# 2006.08.15
################################################################################
sub brc {
  my @x = @_;
  my $bias,$rmse,$corr;

  ( $bias ) = _bias(@x);
  ( $rmse ) = rmse(@x);
  ( $corr ) = corr(@x);

 return ($bias,$rmse,$corr);
}

################################################################################
# κ͡Ǿ
#
#  աƱͤξ,˽ФƤǡȤ
#
# 2006.08.15
################################################################################
sub emax_emin{
  my @xx = @_;
  my @yy;
  my $n   = $#xx+1;
  my $nb2 = $n/2;
  my $err_val = -999.9;
  my @e=(),$err;
  my $emax,$emin,$emaxn,$eminn;

  @yy = splice @xx,$nb2,$nb2;

  foreach $i ( 0..$#xx ){
    if( $xx[$i] < -900 or $yy[$i] < -900 ){
      $err = $err_val; 
    }else{
      $err = $yy[$i] - $xx[$i]; 
    }
    push(@e,$err);
  }

  ($emax,$emaxn) = max(@e);
  ($emin,$eminn) = min(@e);
 return($emax,$emaxn,$emin,$eminn);
}

################################################################################
# κ()
#
#  աƱͤξ,˽ФƤǡȤ
#
# 2006.08.15
################################################################################
sub eamax{
  my @xx = @_;
  my @yy;
  my $n   = $#xx+1;
  my $nb2 = $n/2;
  my $err_val = -999.9;
  my @e=(),$err;
  my $emax,$emin,$emaxn,$eminn;
  my $eamax,$eamaxn,$sign;

  @yy = splice @xx,$nb2,$nb2;

  foreach $i ( 0..$#xx ){
    if( $xx[$i] < -900 or $yy[$i] < -900 ){
      $err = $err_val; 
    }else{
      $err = $yy[$i] - $xx[$i]; 
    }
    push(@e,$err);
  }

  ($emax,$emaxn) = max(@e);
  ($emin,$eminn) = min(@e);
  $eamax = -999.9;$eamaxn=-999,9;$sign=-999.9;
  if($emax > -900 and $emin > -900){
   if(abs($emax) > abs($emin) ){
      $eamax = abs($emax);
      $eamaxn = $emaxn;
      if($emax < 0 ){ $sign = -1;}else{ $sign = 1;}
   }else{
      $eamax = abs($emin);
      $eamaxn = $eminn;
      if($emin < 0 ){ $sign = -1;}else{ $sign = 1;}
   }
  }

 return($eamax,$eamaxn,$sign);
}

################################################################################
# ҥȥ(ѡ) Version 2a (from Version 2, flagɲ)
#
#  label = 0 : ٥
#  label = 1 : ̽
#
#  flag1 = 0 : ξ¦ʬ
#  flag1 = 1 : ¦ͤäˤʬ
#
#  flag2 = 0 : bin˳ꤹv2Ʊ͡
#  flag2 = 1 : bin˳ꤷ
#
# syn:
#   Stat::histp_v2a(٥,ξ¦or¦, binϳor, $min,$max,$bin,@DATA);
#   Stat::histp_v2a($label,$flag1,$flag2,$min,$max,$bin,@DATA);
#
# Last edit date : 2006.09.12
# Last edit date : 2006.10.04
#
sub histp_v2a{
  my $label = shift @_; #" label
  my $flag1 = shift @_; #" 
  my $flag2 = shift @_; #" 
  my $min   = shift @_; #" 
  my $max   = shift @_; #"
  my $bin   = shift @_; #" 
  my @x = @_;
  my @z = ();
  my $err_val = -999.9;
  my @HISTP=(),@LABEL=();
  my $nbin,$bin2;

  #-- error check --#
  foreach my $xx (@x){ if( $xx > $err_val){ push(@z,$xx); } }

 if($flag1 == 1){ $min = 0;}

 if    ($flag2 == 0){         #" bin򳬵ˤ
   $nbin = ($max-$min)/$bin;    #" 
   $bin2 = $bin;                #" 
 }elsif($flag2 == 1){         #" bin򳬵ˤ
   $nbin = $bin;                #" 
   $bin2 = ($max-$min)/$bin;    #" 
   $bin  = $bin2;               #" 
 }

  # initialization #
  foreach $nb (1..$nbin){  $deg{$nb}=0; }
  
  #printf "SUM :%d\n",scalar(@z); 
  my $cnt = 0;
  foreach my $zz (@z){
   if($flag1 == 1){ $zz = abs($zz); }
    $cnt++;
    foreach $nb (1..$nbin){
      $lbin = $min+$bin*$nb - $bin2; 
      $hbin = $min+$bin*$nb; 
      #printf "$zz, $nb, $lbin,$hbin\n";

      if($cnt == 1){ push(@LABEL,$hbin); } #" ٥
      #if($cnt == 1){ push(@LABEL,($hbin - $bin2/2)/$max); } #" ٥

      if    ($nb == 1 ){
        if($zz <= $hbin)                { $deg{$nb}++;}
      }elsif($nb == $nbin){
        if($zz >  $lbin)                { $deg{$nb}++;}
      }else{
        if($zz > $lbin and $zz <= $hbin){ $deg{$nb}++;}
      }    
    }
  }
 
    my $size = scalar(@z); 
    foreach $nb (1..$nbin){
      if($size == 0){
        push(@HISTP,-999.9);
      }else{
        $histp=$deg{$nb}/$size;
        #printf "%4d,%7.4f\n",$min+$bin*$nb,$histp;
        push(@HISTP,$histp);
      }
    }

 if($label == 1){ return (@LABEL); }
 return (@HISTP);
}

################################################################################
# ҥȥ(ѡ) Version 3 (from Version 3, flagɲ)
#
#  flag1 = 0 : ξ¦ʬ
#  flag1 = 1 : ¦ͤäˤʬ
#
#  flag2 = 0 : bin˳ꤹv2Ʊ͡
#  flag2 = 1 : bin˳ꤷ
#
#  lbin <   <= hbin 
# 
# syn:
#   Stat::histp_v3(ξ¦or¦, binϳor, $min,$max,$bin,@DATA);
#   Stat::histp_v3($flag1,$flag2,$min,$max,$bin,@DATA);
#
# Last edit date : 2006.10.11
#
sub histp_v3{
  my $label = shift @_; #" label
  my $flag1 = shift @_; #" 
  my $flag2 = shift @_; #" 
  my $min   = shift @_; #" 
  my $max   = shift @_; #"
  my $bin   = shift @_; #" 
  my @x = @_;
  my @z = ();
  my $err_val = -999.9;
  my @HISTP=(),@LABEL=();
  my $nbin,$bin2,$lb;

  #-- error check --#
  foreach my $xx (@x){ if( $xx > $err_val){ push(@z,$xx); } }

  if($flag1 == 1){ $min = 0;}
  $nbin = $bin;                #" 
  $bin2 = ($max-$min)/$bin;    #" 
  $bin  = $bin2;               #" 

  # initialization #
  foreach $nb (0..$nbin){  $deg{$nb}=0; }
  
  #printf "SUM :%d\n",scalar(@z); 
  my $cnt = 0;
  foreach my $zz (@z){
   if($flag1 == 1){ $zz = abs($zz); }
    $cnt++;
    foreach $nb (0..$nbin){
      $lbin = $min+$bin*$nb - $bin2/2; 
      $hbin = $min+$bin*$nb + $bin2/2; 
      #printf "$nb, $lbin,$hbin\n";

      $lb=($hbin - $bin2/2)/$max;
      if($cnt == 1){ push(@LABEL,$lb); }
      if   ($nb == 0 )   { $lbin *= 10; }
      elsif($nb == $nbin){ $hbin *= 10; }
      if($zz > $lbin and $zz <= $hbin){ $deg{$nb}++;}

      #if    ($nb == 0 ){
      #  if($zz <= $hbin)                { $deg{$nb}++;}
      #}elsif($nb == $nbin){
      #  if($zz > $lbin)                 { $deg{$nb}++;}
      #}else{
      #  if($zz > $lbin and $zz <= $hbin){ $deg{$nb}++;}
      #}    

      #if($cnt == 1){ 
      #  printf "$nb, %7.2f < <= %7.2f, %7.2f\n",$lbin,$hbin,$lb;
      #}
    } #" $nb
  } #" $zz
 
    my $size = scalar(@z); 
    foreach $nb (0..$nbin){
      if($size == 0){
        push(@HISTP,-999.9);
      }else{
        $histp=$deg{$nb}/$size;
        #printf "%4d,%7.4f\n",$min+$bin*$nb,$histp;
        #printf "%7.1f, %d\n",$LABEL[$nb],$deg{$nb};
        push(@HISTP,$histp);
      }
    }

 if($label == 1){ return (@LABEL); }
 return (@HISTP);
}

################################################################################
# ҥȥ(ѡ) Version 4 (from Version 4)
#
#  lbin <   <= hbin 
# 
# syn:
#   Stat::histp_v3(٥,binϳ,$min,$max,$bin,@DATA);
#   Stat::histp_v3($label,$min,$max,$bin,@DATA);
#
# Last edit date : 2006.10.11
#
sub histp_v4{
  my $label = shift @_; #" label
  my $min   = shift @_; #" 
  my $max   = shift @_; #"
  my $bin   = shift @_; #" 
  my @x = @_;
  my @z = ();
  my $err_val = -999.9;
  my @HISTP=(),@LABEL=();
  my $nbin,$bin2,$lb;

  #-- error check --#
  foreach my $xx (@x){ if( $xx > $err_val){ push(@z,$xx); } }

  $bin;                     #" 
  $bin2 = $bin;             #" 
  $nbin = ($max-$min)/$bin; #" 

  # initialization #
  foreach $nb (1..$nbin){  $deg{$nb}=0; }
  
  my $cnt = 0;
  foreach my $zz (@z){
    $cnt++;
    foreach $nb (1..$nbin){
      $lbin = $min+$bin*($nb-1); 
      $hbin = $min+$bin*($nb-1) + $bin2; 
      if   ($nb == 1 )   { $lbin *= 10; }
      elsif($nb == $nbin){ $hbin *= 10; }

      ###  ###
      if    ($lbin < 0){
        if($zz >= $lbin and $zz <  $hbin){
             $deg{$nb}++;
        }
        $lb=$lbin;
        if($cnt == 1){ push(@LABEL,$lb); }
        #if($cnt == 1){ 
        #  printf "$nb, %7.2f <= < %7.2f, %7.2f\n",$lbin,$hbin,$lb;
        #}
      ### zero ###
      }elsif($lbin == 0){
        if($zz >= $lbin and $zz <=  $hbin){
             $deg{$nb}++;
        }
        $lb=$hbin;
        if($cnt == 1){ push(@LABEL,$lb); }
        #if($cnt == 1){ 
        #  printf "$nb, %7.2f <= <= %7.2f, %7.2f\n",$lbin,$hbin,$lb;
        #}
      ###  ###
      }elsif($lbin > 0){
        if($zz >  $lbin and $zz <= $hbin){
             $deg{$nb}++;
        }
        $lb=$hbin;
        if($cnt == 1){ push(@LABEL,$lb); }
        #if($cnt == 1){ 
        #  printf "$nb, %7.2f < <= %7.2f, %7.2f\n",$lbin,$hbin,$lb;
        #}
      }
    } #" $nb
  } #" $zz
 
    my $size = scalar(@z); 
    foreach $nb (1..$nbin){
      if($size == 0){
        push(@HISTP,-999.9);
      }else{
        $histp=$deg{$nb}/$size;
        #printf "%4d,%7.4f\n",$min+$bin*$nb,$histp;
        #printf "%7.1f, %d\n",$LABEL[$nb-1],$deg{$nb};
        push(@HISTP,$histp);
      }
    }

 if($label == 1){ return (@LABEL); }
 return (@HISTP);
}

################################################################################
# STAT3 (BIAS,RMSE,CORR) ,EMAX,EMAX5
#
# 2006.09.17
# 2007.02.13 mybug fix
################################################################################
sub stat3{
  my @x = @_;
  my (@d,@d2,@ds);
  my $n   = $#x+1;
  my $nb2 = $n/2;
  my @y;
  my ($bias,$rmse,$corr);

  ( $bias ) = bias(@x);
  ( $rmse ) = rmse(@x);
  @y = splice @x,$nb2,$nb2;
  ( $corr ) = corr(@x,@y);

 return ($bias,$rmse,$corr);
} #" stat3


################################################################################
# STAT5 (BIAS,RMSE,CORR, PEMAX,MEMAX,PEMAX5,MEMAX5)
#
# 2006.09.17
# 2007.02.13 mybug fix
################################################################################
sub stat5{
  my @x = @_;
  my (@d,@d2,@ds);
  my $n   = $#x+1;
  my $nb2 = $n/2;
  my @y;
  my ($bias,$rmse,$corr);
  my $err_val = -999.9;
  my (@se,@e,$e1,$g1,$num5);
  my ($pemax,$memax,$pemax5,$memax5);
  $bias = -999.9;$rmse = -999.9;$corr = -999.9;
  @e = ();@se = ();

  ( $bias ) = bias(@x);
  ( $rmse ) = rmse(@x);

  @y = splice @x,$nb2,$nb2;
  ( $corr ) = corr(@x,@y);

  foreach $g1 (0..$#x){
    $x1 = $x[$g1];
    $y1 = $y[$g1];
    if($x1 < -900 or $y1 < -900){ $e1 = $err_val;}
    else                        { $e1 = $y1 - $x1;}
    push(@e,$e1);
  }

  @se = sort {$a <=> $b} @e;
  $pemax = $se[$#se];
  $memax = $se[0];

  # 5%Υǡʿͻ #
  $num5 = int(scalar(@e)*0.05);
  $pe=0;$me=0;
  foreach $g (($#se-($num5-1))..$#se){ $pe += $se[$g]; }
  foreach $g (0..($num5-1))          { $me += $se[$g]; }
    if($num5 > 0){
      $pemax5 = $pe/$num5;
      $memax5 = $me/$num5;
    }else{
      $pemax5 = -999.9;
      $memax5 = -999.9;
    }
 return ($bias,$rmse,$corr,$pemax,$memax,$pemax5,$memax5);
} #" stat5

1;
