#!/usr/bin/perl
#####################################################################
# platform_lib.pl
# 2007.03.26
#####################################################################
sub ctrl_time {

  use Time::Local;
  my ($ymdhm0) = @_;
  my ($ftime,$tn);
  my ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1,$tn1);

  my $yy = substr($ymdhm0,0,2);
  my $mm = substr($ymdhm0,2,2);
  my $dd = substr($ymdhm0,4,2);
  my $hh = substr($ymdhm0,6,2);
  my $mn = 1*substr($ymdhm0,8,2);

#  print "%%% $yy,$mm,$dd,$hh,$mn\n"; 

  my $pday = 1;

  if($mn >= 0 and $mn <= 25){ $mn =  0; $ftime=0; }
  elsif($mn > 25 and $mn <= 55){ $mn = 30; $ftime=0; }
  elsif($mn > 55 and $mn <= 59){ $mn =  0; $ftime=1; }
  else { print "NNNNNNNN \n";}

  my $sc = 0; 
  $mm--;
  $tn  = timelocal( $sc,$mn,$hh,$dd,$mm,$yy );
  $tn += $ftime*3600; 
  ($sc,$mn,$hh,$dd,$mm,$yy) = localtime($tn);
  $mm++; $yy%=100;
  my $ymdhm = sprintf "%02d%02d%02d%02d%02d",$yy,$mm,$dd,$hh,$mn;
  $tn1 = $tn-($pday*86400);
  ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1) = localtime($tn1);
  $mm1++; $yy1%=100;
  my $ymdhm1 = sprintf "%02d%02d%02d%02d%02d",$yy1,$mm1,$dd1,$hh1,$mn1;

#  print "%%% ymdhm=$ymdhm\n";
#  print "%%% ymdhm1=$ymdhm1\n";

  return($ymdhm,$ymdhm1);

}

sub ctrl_time_d {

  use Time::Local;
  my ($ymdhm) = @_;
  my ($tn,$tn1,$ftime);
  my ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1);

  my ($yy,$mm,$dd,$hh,$mn) = $ymdhm =~/(\d\d)(\d\d)(\d\d)(\d\d)(\d\d)/; 
  my $hhmm = 1*sprintf("%02d%02d",$hh,$mn);

  if ( $hhmm >= 1800 ) { 
      $ftime = 0; $hh = "09";
  } elsif ( $hhmm >= 0 and $hhmm <= 530 ) {
      $ftime = 1; $hh = "09";
  } elsif ( $hhmm >= 600 and $hhmm <= 1730 ) {
      $ftime = 1; $hh = "21"; 
  } 

  my $phour = 12;
  
  my $sc = 0;
  $mm--;
  $tn  = timelocal( $sc,$mn,$hh,$dd,$mm,$yy );
  ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1) = localtime($tn-$ftime*86400);
  $mm1++; $yy1%=100;
  my $ymdh1 = sprintf "%02d%02d%02d%02d",$yy1,$mm1,$dd1,$hh1;

  $sc1 = 0;
  $mm1--;
  $tn1  = timelocal( $sc1,$mn1,$hh1,$dd1,$mm1,$yy1 );
  ($sc2,$mn2,$hh2,$dd2,$mm2,$yy2) = localtime($tn1-$phour*3600);
  $mm2++; $yy2%=100;
  my $ymdh2 = sprintf "%02d%02d%02d%02d",$yy2,$mm2,$dd2,$hh2;
  
  return($ymdh1,$ymdh2);

}

sub ctrl_time_p1day {

  use Time::Local;
  my ($ymdhm0,$DDD) = @_;
  my ($ftime,$tn);
  my ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1,$tn1);

  my $yy = substr($ymdhm0,0,2);
  my $mm = substr($ymdhm0,2,2);
  my $dd = substr($ymdhm0,4,2);
  my $hh = substr($ymdhm0,6,2);
  my $mn = 1*substr($ymdhm0,8,2);

#  print "%%% $yy,$mm,$dd,$hh,$mn\n";

  my $sc = 0;
  $mm--;
  $tn  = timelocal( $sc,$mn,$hh,$dd,$mm,$yy );
  $tn1 = $tn-($DDD*86400);
  ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1) = localtime($tn1);
  $mm1++; $yy1%=100;
  my $ymdhm1 = sprintf "%02d%02d%02d%02d%02d",$yy1,$mm1,$dd1,$hh1,$mn1;

#  print "%%% ymdhm1=$ymdhm1\n";

  return($ymdhm1);

}

sub ctrl_time_mday {

  use Time::Local;
  my ($ymdhm0,$DDD) = @_;
  my ($ftime,$tn);
  my ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1,$tn1);

  my $yy = substr($ymdhm0,0,4);
  my $mm = substr($ymdhm0,4,2);
  my $dd = substr($ymdhm0,6,2);
  my $hh = substr($ymdhm0,8,2);
  my $mn = 1*substr($ymdhm0,10,2);

  print "%%% $yy,$mm,$dd,$hh,$mn\n";

  my $sc = 0;
  $mm--;
  $tn  = timelocal( $sc,$mn,$hh,$dd,$mm,$yy );
  $tn1 = $tn-($DDD*86400);
  ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1) = localtime($tn1);
  $mm1++; 
  $yy1 = $yy1+1900;
  my $ymdhm1 = sprintf "%04d%02d%02d%02d%02d",$yy1,$mm1,$dd1,$hh1,$mn1;

#  print "%%% ymdhm1=$ymdhm1\n";

  return($ymdhm1);

}

sub ctrl_time_pday {

  use Time::Local;
  my ($ymdhm0,$DDD) = @_;
  my ($ftime,$tn);
  my ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1,$tn1);

  my $yy = substr($ymdhm0,0,4);
  my $mm = substr($ymdhm0,4,2);
  my $dd = substr($ymdhm0,6,2);
  my $hh = substr($ymdhm0,8,2);
  my $mn = 1*substr($ymdhm0,10,2);

#  print "%%% $yy,$mm,$dd,$hh,$mn\n";

  my $sc = 0;
  $mm--;
  $tn  = timelocal( $sc,$mn,$hh,$dd,$mm,$yy );
  $tn1 = $tn+($DDD*86400);
  ($sc1,$mn1,$hh1,$dd1,$mm1,$yy1) = localtime($tn1);
  $mm1++;
  $yy1 = $yy1+1900;
  my $ymdhm1 = sprintf "%04d%02d%02d%02d%02d",$yy1,$mm1,$dd1,$hh1,$mn1;

#  print "%%% ymdhm1=$ymdhm1\n";

  return($ymdhm1);

}


1;

