#####################################################################
# mk_dataset_realfst.pl
#
#  Υǡ
#  Useage ./mk_dataset_realfst.pl TABLE_FILE AREA_NUM WF_NUM -t YYMMDDHHmm\n YYMMDDHHmm:JST
#  -t ץǻ򤷤ʤϡǿǽ
#
#####################################################################
require "./platform_lib.pl";

$TABLE = $ARGV[0];
$AREA_NUM = $ARGV[1];
$POINT_NUM = $ARGV[2];
require "$TABLE";

use Getopt::Long;
use Time::Local;
$Getopt::Long::ignorecase=undef;
GetOptions('t=s');

#######    ###################
if( $opt_t ne "" && length($opt_t)!=10 ){
   die "Usage ./mk_dataset_realfst.pl TABLE_FILE AREA_NUM WF_NUM -t YYMMDDHHmm\n YYMMDDHHmm:JST\n";
}elsif( length( $opt_t ) == 10 ){
    $jyear4=1*substr($opt_t,0,2)+2000;
    $jyear2=1*substr($opt_t,0,2);
    $jmonth =1*substr($opt_t,2,2);
    $jday =1*substr($opt_t,4,2);
    $jhour=1*substr($opt_t,6,2);
    $jmin=1*substr($opt_t,8,2);
}else{
    $jst = time();
    ($jsec,$jmin,$jhour,$jday,$jmonth,$jyear)=localtime( $jst );
    $jyear4=$jyear+1900; $jyear2=$jyear4%100; $jmonth++;
}

$y2mdhm = sprintf("%02d%02d%02d%02d%02d",$jyear2,$jmonth,$jday,$jhour,$jmin);
$y4mdhm = sprintf("%04d%02d%02d%02d%02d",$jyear4,$jmonth,$jday,$jhour,$jmin);
print "Y4MDHM=$y4mdhm,$y2mdhm\n";

($n_ymdhm,$n_ymdhm1) = ctrl_time($y2mdhm);
print "001 : $n_ymdhm,$n_ymdhm1\n";
#$n_ymdhm = "0709071200";

($y4mdhm_m1) = ctrl_time_mday($y4mdhm,1);  #1
($y4mdhm_p1) = ctrl_time_pday($y4mdhm,1);  #1
($y4mdhm_p2) = ctrl_time_pday($y4mdhm,2);  #2
$y4md = substr("$y4mdhm",0,8);
$y4md_m1 = substr("$y4mdhm_m1",0,8);
$y4md_p1 = substr("$y4mdhm_p1",0,8);
$y4md_p2 = substr("$y4mdhm_p2",0,8);
$y2md = substr("$y4mdhm",2,6);
$y2md_m1 = substr("$y4mdhm_m1",2,6);
$y2md_p1 = substr("$y4mdhm_p1",2,6);
$y2md_p2 = substr("$y4mdhm_p2",2,6);

$o_dir_ym = substr("$y4mdhm",2,4);
$o_dir_ym_m1 = substr("$y4mdhm_m1",2,4);

#### ʽϻ########################
if ( $POWER_MAX <= 0) { exit; }
##########################################


################################
##   open output file         ##
################################
open(OUT,">$REAL_DSET_File");
print "OUT=$REAL_DSET_File\n";

###########################################
#---  Observation + forecast File     --- #
###########################################
$MNEW_FLG = 0;
foreach  $y4md_date ( $y4md_m1,$y4md ){
  for ($hh=0;$hh<=23;$hh++) {
    foreach $min ( 00,30 ) {

      $obsf = sprintf("%ss%s_%08d%02d%02d.csv",$AREA_NUM,$POINT_NUM,$y4md_date,$hh,$min);

      $obs_ym = substr("$obsf",9,4);
      $obs_ymd = substr("$obsf",9,6); 
      $obs_ymdhm = substr("$obsf",9,10); 
      $hh = sprintf("%02d",$hh);
      #$min = sprintf("%02d",$min);

      $obs_yy2 = substr("$obsf",9,2);
      $obs_mm = substr("$obsf",11,2);
      $obs_dd = substr("$obsf",13,2);

      if ( $n_ymdhm <= $obs_ymdhm ) {
        $MNEW_FLG = 1;
        last;
      }

      $OFile = sprintf("%s/c%s/%s",$OBS_DIR,$obs_ym,$obsf);
       print "OFile = $OFile\n";
      unless ( -e $OFile ) {
        printf OUT ("%02d,%02d,%02d,%02d,%02d,,,,,,,,,,,,\n",$obs_yy2,$obs_mm,$obs_dd,$hh,$min);
        next;
      }
      
      @dummy=(); 
      open(IN1,"<$OFile");
        @dummy = <IN1>;
      close(IN1);

      foreach $obs_line (@dummy) {
        @buf_o=();
        chomp($obs_line);
        next if ($obs_line =~ /^#/);
        @buf_o = split(/,/,"$obs_line");
        $buf_o[5] = 1*$buf_o[5];  #--kW
        $buf_o[6] = 1*$buf_o[6];  #--%
        print "#####0 buf_o[5]=$buf_o[5]\n";
        if ( $buf_o[5] < 0 and $buf_o[5] > -900) { 
          $buf_o[5] = "0.00";
          $P_efficiency_obs = "0.00";
        } elsif ( $buf_o[5] <= -900 ) {
          $buf_o[5] = "";
          $P_efficiency_obs = "";
        } else {
          $buf_o[5] = sprintf("%.2f",$buf_o[5]/1000.);
          $P_efficiency_obs = sprintf("%.2f",($buf_o[5]/$POWER_MAX)*100);
          #$P_efficiency_obs = sprintf("%.2f",$buf_o[6]);
        } 
        print "#####1  buf_o[5]=$buf_o[5]\n";

        #--- ¬Ʊͽ¬ǡ
        $fcs_flg = 0;
        #--- ¶3ͽ¬ǡ¶ͽ¬ͤ롣
        $obs_YY=1*substr($obs_ymdhm,0,2)+2000;
        $obs_MM=1*substr($obs_ymdhm,2,2);
        $obs_DD=1*substr($obs_ymdhm,4,2);
        $obs_HH=1*substr($obs_ymdhm,6,2);
        $obs_MN=1*substr($obs_ymdhm,8,2);
        $obs_time_m3 = timelocal(0,$obs_MN,$obs_HH,$obs_DD,$obs_MM-1,$obs_YY);
        ($sec_f,$min_f,$hour_f,$mday_f,$mon_f,$year_f,$wday_f,$yday_f,$isdist_f) = localtime($obs_time_m3-3*3600);
        $mon_f++;
        $year_f4 = $year_f+1900;
        $year_f2 = $year_f4 % 100;
        $obs_ymdhm_m3 = sprintf("%02d%02d%02d%02d%02d",$year_f2,$mon_f,$mday_f,$hour_f,$min_f);

        ($fsc_ymdhm,$fsc_ymdhm1) = ctrl_time_d($obs_ymdhm_m3);
        print "fsc_ymdhm=$fsc_ymdhm, obs_ymdhm=$obs_ymdhm,obs_ymdhm_m3=$obs_ymdhm_m3\n";

        #$fcs_dir_ym = substr("$fsc_ymdhm",0,4);
        $fcs_dir_ym = substr("$obs_ymdhm_m3",0,4);
        $fcs_dir = sprintf("%s/c%s",$FST_DIR,$fcs_dir_ym);
        $FFile = sprintf("%s/%sf%s_20%s.csv",$fcs_dir,$AREA_NUM,$POINT_NUM,$obs_ymdhm_m3);
        print "FFile = $FFile\n";
        open(FF,"<$FFile");
        for($i=0;$i<10;$i++) {
           $dumy=<FF>;
        }
        while(<FF>){
          @buf_f = ();
          chomp($_);
          @buf_f = split(/,/,"$_");
          $buf_f[5] = $buf_f[5]*1;
          print "$buf_f[0],$buf_f[1],$buf_f[2],$buf_f[3],$buf_f[4],$buf_f[5]\n"; 
          $buf_f0_yy = substr("$buf_f[0]",2,2);
          $date_time = sprintf("%02d%02d%02d%02d%02d",$buf_f0_yy,$buf_f[1],$buf_f[2],$buf_f[3],$buf_f[4]);
          if ( $date_time ne $obs_ymdhm ) { 
              next; 
          } else {
            $fcs_flg = 1;
            for($k=5;$k<=9;$k++){
              $buf_f[$k] = sprintf("%.2f",1*$buf_f[$k]);
              if ( $buf_f[$k] < 0 and $buf_f[$k] > -90000) {
                $buf_f[$k] = "0.00";
                $P_efficiency_fcs[$k] = "0.00"; 
              } elsif ( $buf_f[$k] <= -90000 ) {
                $buf_f[$k] = "";
                $P_efficiency_fcs[$k] = "";
              } else {
                $buf_f[$k] = sprintf("%.2f",$buf_f[$k]/1000.0);
                $P_efficiency_fcs[$k] = sprintf("%.2f",($buf_f[$k]/$POWER_MAX)*100);
              }
            } #for
            last;
          }
        } #while(<FF>)
        close(FF);
  
        #-- ¬͡ͽ¬ͤν
        $of_date = sprintf("%02d,%02d,%02d,%02d,%02d",$obs_yy2,$obs_mm,$obs_dd,$hh,$min);
        if ( $fcs_flg == 1 ) {
           print OUT "$of_date,$buf_o[5],$P_efficiency_obs,$buf_f[5],$P_efficiency_fcs[5],$buf_f[6],$P_efficiency_fcs[6],$buf_f[7],$P_efficiency_fcs[7],$buf_f[8],$P_efficiency_fcs[8],$buf_f[9],$P_efficiency_fcs[9]\n";
#          printf OUT ("%02d,%02d,%02d,%02d,%02d,%s,%s,%s,%s,trst_up,trst_dwn\n",$obs_yy2,$obs_mm,$obs_dd,$hh,$min,$buf_o[5],$P_efficiency_obs,$buf_f[5],$P_efficiency_fcs);
        } else {
           print OUT "$of_date,$buf_o[5],$P_efficiency_obs,,,,,,,,,,\n";
#          printf OUT ("%02d,%02d,%02d,%02d,%02d,%s,%s,,,trst_up,trst_dwn\n",$obs_yy2,$obs_mm,$obs_dd,$hh,$min,$buf_o[5],$P_efficiency_obs);
        }

      } #foreach $obs_line (@dummy)

    } #foreach $min ( 00,30 ) {

    if ( $MNEW_FLG == 1 ) {
      last;
    }

  } #for ($hh=0;$hh<=23;$hh++) {

  if ( $MNEW_FLG == 1 ) {
     last;
  }

} #foreach  $y4md_date ( $y4md_m1,$y4md ){


#############################################
#--- Forecast Data Directry Check    ---#####
#############################################
$Fdir = sprintf("%s/c%s",$FST_DIR,$o_dir_ym);
print "Fdir = $Fdir\n";

$file_match = sprintf("%sf%s_%s",$AREA_NUM,$POINT_NUM,$y4md);
$file_match_m1 = sprintf("%sf%s_%s",$AREA_NUM,$POINT_NUM,$y4md_m1);

@file = ();
opendir(DIR, $Fdir);
  @file = sort grep { /$file_match/i && -f "$Fdir/$_"} readdir(DIR);
closedir(DIR);
unless (defined($file[0])) {
  @file = ();
  $Fdir = sprintf("%s/c%s",$FST_DIR,$o_dir_ym_m1) or die;
  opendir(DIR, $Fdir);
    @file = sort grep { /$file_match_m1/i && -f "$Fdir/$_"} readdir(DIR);
  closedir(DIR);
  unless (defined($file[0])) {
    exit;
  }
}

$nmax = 0;
foreach $fcsfile ( sort @file ){
  print "fcsfile=$fcsfile\n";
  $file_time = substr("$fcsfile",9,10);
  if ( $file_time <= $n_ymdhm and $nmax < $file_time ) {
     $nmax = $file_time;
  } 
}

################################
#---  Forecast File        --- #
################################
$FFile = sprintf("%s/c%s/%sf%s_20%s.csv",$FST_DIR,$o_dir_ym,$AREA_NUM,$POINT_NUM,$nmax);
print "FST OpenFile = $FFile\n";
@dat=();
open(IN2,"<$FFile");
    @dat=<IN2>;
close(IN2);
$Lpdate =sprintf("%s0000",$y2md_p2); 

foreach $line ( @dat ){
    @buf = ();
    chomp($line);
    next if ($line =~ /^#/);
    @buf = split(/,/,$line);
    $buf[5] = $buf[5]*1;   # unit=kW
    $buf_yy = substr($buf[0],2,2);
    $date_time = sprintf("%02d%02d%02d%02d%02d",$buf_yy,$buf[1],$buf[2],$buf[3],$buf[4]);
    $ff_date = sprintf("%02d,%02d,%02d,%02d,%02d",$buf_yy,$buf[1],$buf[2],$buf[3],$buf[4]);
    if (( $date_time >= $n_ymdhm) and ($date_time <= $Lpdate )) {
      for($k=5;$k<=9;$k++){
        $buf[$k] = sprintf("%.2f",$buf[$k]);
        if ( $buf[$k] < 0 and $buf[$k] > -90000) {
           $buf[$k] = "0.00";
           $P_efficiency_fcs[$k] = "0.00";
        } elsif ( $buf[$k] <= -90000 ){
           $buf[$k] = "";
           $P_efficiency_fcs[$k] = "";
        } else {
           $buf[$k] = sprintf("%.2f",($buf[$k]/1000.0));
           $P_efficiency_fcs[$k] =sprintf("%.2f",($buf[$k]/$POWER_MAX)*100);
        }
      } #for
      print OUT "$ff_date,,,$buf[5],$P_efficiency_fcs[5],$buf[6],$P_efficiency_fcs[6],$buf[7],$P_efficiency_fcs[7],$buf[8],$P_efficiency_fcs[8],$buf[9],$P_efficiency_fcs[9]\n";

#      printf OUT ("%02d,%02d,%02d,%02d,%02d,,,%s,%s,trst_up,trst_dwn\n",$buf_yy,$buf[1],$buf[2],$buf[3],$buf[4],$buf[5],$P_efficiency);
    }
  }

close(OUT);

exit;
