#!/usr/bin/perl
#####################################################################
# mk_ctc_pic_errdist.pl
#
# Usage : ./mk_ctc_pic_errdist_tm.pl [TABLE]
#
# 2007.08.14
#####################################################################
use Time::Local;
use GD;
use GD::Text;
use GD::Graph::mixed;

$table = $ARGV[0];

require "./$table";

#######    ###################
$jst = time();
($jsec,$jmin,$jhour,$jday,$jmonth,$jyear)=localtime( $jst );
    $jyear4=$jyear+1900; $jyear2=$jyear4%100; $jmonth++;

####### OPEN FILE  ###################
$OPEN_F=sprintf("%s/hist1_a%s_p%s.csv",$TMPDIR,$AREA_NUM,$POINT_NUM);
unless ( -e $OPEN_F ) {
  $rjst = $jst - 10*86400;
  ($rsec,$rmin,$rhour,$rday,$rmonth,$ryear)=localtime( $rjst );
    $ryear4=$ryear+1900; $ryear2=$ryear4%100; $rmonth++;
  $OPEN_F=sprintf("%s/hist1_a%s_p%s.csv",$TMPDIR,$AREA_NUM,$POINT_NUM);
}
unless ( -e $OPEN_F ) { exit; }

##################
###  make fig. ###
##################

@ERR0=();@FRQ0=();@NRMAL0=();
  #----------------------------------------------
  # Input / Output File Setting
  #----------------------------------------------
  $ktn ="TM";
  #$ofile = sprintf("%s/%s",$OUTPUTDIR,$HSTFile_Tomorrow3h);
  $ofile = sprintf("%s/%s",$OUTPUTDIR,$HSTFile_Tomorrow);
  $title_parts = sprintf("%s/pic_parts/CNT321_title.png",$EXE_DIR);
  $title = "        ";
  #$title = " Tomorrow's 3hour Forecast Error [%]";
  $hanrei_parts = sprintf("%s/pic_parts/hanrei_CNT311.png",$EXE_DIR);
  $X_axis_parts = sprintf("%s/pic_parts/Xaxis_CNT311.png",$EXE_DIR);

  print " <- $OPEN_F\n";
  print " -> $ofile\n";

  #----------------------------------------------
  #  Read Inputfile
  #---------------------------------------------- 
  $sMax = 0;
  open(IN,"<$OPEN_F");
  while(<IN>){
    chomp $_; 
    @buf = split(/,/, $_);
    if ( $buf[0] ne $ktn ) { next; }
    for($ii=0;$ii<=23;$ii++) {
      $jj = 9;
      push(@ERR0,$ii);
      $buf[$jj+$ii] = sprintf("%.2f",$buf[$jj+$ii]*100);

#--- Ѥ˺ͤ¸
      if ( $sMax < $buf[$jj+$ii]) { $sMax = $buf[$jj+$ii];}

      push(@FRQ0,$buf[$jj+$ii]);
      print "t=$ktn,ii=$ii,frq=$buf[$jj+$ii]\n";
    }
  }
  close(IN);

  #----------------------------------------------
  my @data  = (\@ERR0,\@FRQ0);
  #----------------------------------------------

  #----------------------------------------------
  # 
  #----------------------------------------------
  $xwidth= 600;
  $y1_label = "Frequency [%]";
  $x1_label = "[ Forecast Error ME/RC [%] ]"; 
  $title = sprintf("%s",$title);
  $y1_max=50;
  $y1_min=0;
  $xlskip = 3;

  #-- ļβ
  $sMax = (int($sMax/10+1))*10;
  if ( $y1_max < $sMax ) { $y1_max = $sMax;}

  $y_jiku_num = int($y1_max/10);

  my $graph = GD::Graph::mixed->new( $xwidth, 280 );
#  my $graph = GD::Graph::mixed->new( $xwidth, 294 );
#  $graph->set_legend("ME(%)","MAE(%)","RMSE(%)");
  $graph->set_x_label_font(gdLargeFont);
  $graph->set_y_label_font(gdLargeFont);
  $graph->set_x_axis_font(gdLargeFont);
  $graph->set_y_axis_font(gdLargeFont);
   
  $graph->set(
       two_axes => 0,
       t_margin => 10,
       b_margin => 10,
       l_margin => 10,
       r_margin => 10,
       title   => "$title",
       y_label => "$y1_label",
       y_max_value => $y1_max,
       y_min_value => $y1_min,
       x_label => $x1_label,
       x_label_position => 1/2,
       #types   => [ qw(linespoints linespoints linespoints) ],
       types   => [ qw(bars) ],
       bgclr   => "white",
       fgclr   => "black",
       boxclr  => "white",
#       shadowclr => "DarkSlateGrey",
#       shadow_depth => 1,
       #dclrs => [ "myred" ],
       #dclrs => [ "myred", "IndianRed" ],
       #dclrs => [ "black","red","green","blue","orange","gray" ],
       dclrs => [ "red" ],
       #accentclr => "black",
       #accentclr => "myred",
       #line_width => [qw(2 1)],
       line_width => 2,
       line_types => [qw(1 1 1)],
       #bar_spacing => 1,
       x_label_skip => $xlskip,
       x_tick_offset => 12,
#       y_tick_number => 5,
       y_tick_number => "$y_jiku_num",
       y_label_skip  => 1,
       long_ticks  => 0,
#       y_long_ticks  => 1,
       skip_undef => 1,
       markers     => [ 1,5,7 ],
       marker_size => 3,
       bar_width => 20,
       bar_spacing => 1,
       box_axis => true,
  );
  #----------------------------------------------

  #----------------------------------------------
  # PLOT
  #----------------------------------------------
  $gra = "";
#  printf "\n Plot data\n";
  $gra = $graph->plot(\@data);

#  $fig = new GD::Image(600,294);
  $fig = new GD::Image(600,320);
  $whilte = $fig->colorAllocate(255,255,255);
  $fig->fill(600,280,$whilte);
  $fig->copy($gra,0,0,0,0,600,240);
  $title_p = GD::Image->newFromPng("$title_parts");
  $hanrei_p = GD::Image->newFromPng("$hanrei_parts");
  $x_axis_p = GD::Image->newFromPng("$X_axis_parts");
  $fig->copy($title_p,105,2,0,0,390,25);
  $fig->copy($hanrei_p,452,35,0,0,109,34);
  $fig->copy($x_axis_p,55,230,0,0,520,82);

open(IMG,">$ofile");
   binmode IMG;
   print IMG $fig->png;
close(IMG);


exit;
