#!/usr/bin/perl
#####################################################################
# mk_pic_csv_errtime_tm.pl
#
# Usage : ./mk_pic_csv_errtime_tm.pl mk_pic_csv_errtime_aXX_pXXX.tab
#
# 2007.08.13
#####################################################################
use Time::Local;
use GD;
use GD::Text;
use GD::Graph::mixed;

$table = $ARGV[0];

require "./$table";

#######    ###################
$jst = time();
($jsec,$jmin,$jhour,$jday,$jmonth,$jyear)=localtime( $jst );
    $jyear4=$jyear+1900; $jyear2=$jyear4%100; $jmonth++;

####### OPEN FILE  ###################
$OPEN_F=sprintf("%s/stat1_a%s_p%s.csv",$TMPDIR,$AREA_NUM,$POINT_NUM);
unless ( -e $OPEN_F ) {
  $rjst = $jst - 10*86400;
  ($rsec,$rmin,$rhour,$rday,$rmonth,$ryear)=localtime( $rjst );
    $ryear4=$ryear+1900; $ryear2=$ryear4%100; $rmonth++;
  $OPEN_F=sprintf("%s/stat1_a%s_p%s.csv",$TMPDIR,$AREA_NUM,$POINT_NUM);
}
unless ( -e $OPEN_F ) { exit; }

#####################
##  make csv data ###
#####################

($dev, $ino, $mode, $nlink, $uid, $gid, $rdev, $size,
    $atime, $mtime, $ctime, $blksize, $blocks) = stat($OPEN_F);
if($size < 300 ) { exit;}

open(IND,"<$OPEN_F") or die;
  @lines = <IND>;
close(IND);

#open(OUT1,">$OUTPUTDIR/$CSVFile_Today");
open(OUT2,">$OUTPUTDIR/$CSVFile_Tomorrow");

foreach $line ( @lines ) {
    chomp $line;
    ($ktn,$ME,$MAE,$RMSE,$CORR,$CAPA,$DNUM,$NME,$NMAE,$NRMSE) = split(/,/, $line);
    #-- ֽktnϡ6:00Υǡ
    if ( $ktn eq "KTN" ) { next; }
    $ktn = 1*$ktn - 36; 
    $ktn = sprintf("%.1f",$ktn * 0.5);
    if ( $NME ne "") {
        $NME = sprintf("%.1f",$NME *100);
    }
    if ( $NMAE ne "" ) {
        $NMAE = sprintf("%.1f",$NMAE *100);
    }
    if (( $NRMSE ne "" )and( $NRMSE >= 0.01)) {
        $NRMSE = sprintf("%.1f",$NRMSE *100);
    }else {
        $NRMSE = "";
    }
    if (( $ktn >= 0.0 ) and ( $ktn <= 24.0 )) { 
      print OUT2 "$ktn,$NME,$NMAE,$NRMSE\n";
    }
}

#close(OUT1);
close(OUT2);


##################
###  make fig. ###
##################

@YHOUR0=();@ME0=();@MAE0=();@RMSE0=();
#----------------------------------------------
# Input / Output File Setting
#----------------------------------------------
$ifile = sprintf("%s/%s",$OUTPUTDIR,$CSVFile_Tomorrow);
$ofile = sprintf("%s/%s",$OUTPUTDIR,$PNGFile_Tomorrow);
$title_parts = sprintf("%s/pic_parts/CNT221_title.png",$EXE_DIR);
$hanrei_parts = sprintf("%s/pic_parts/hanrei_CNT211.png",$EXE_DIR);
$title = "        ";
#$title = " Tomorrow's Forecast Error [%] ";

print " <- $ifile\n";
print " -> $ofile\n";

#----------------------------------------------
#  Read Inputfile
#---------------------------------------------- 
  $sMax = 0;
  $sMin = 0;
  open(IN,"<$ifile");
  while(<IN>){
    chomp $_; 
    ($yhour,$ME,$MAE,$RMSE) = split(/,/, $_);
    $date = sprintf("%s",$hhmm);
    if ( $ME eq "" or $ME < -900 ) { undef $ME;}
    if ( $MAE eq "" or $MAE < -900 ) { undef $MAE;}
    if ( $RMSE eq "" or $RMSE < -900 ) { undef $RMSE;}
#    print "DAT=$yhour,$ME,$MAE,$RMSE\n";
#--- Ѥ˺ͺǾͤ¸
    if ( $sMax < $ME ) { $sMax = $ME;}
    if ( $sMax < $MAE ) { $sMax = $MAE;}
    if ( $sMax < $RMSE ) { $sMax = $RMSE;}
    if ( $sMin > $ME ) { $sMin = $ME;}
    if ( $sMin > $MAE ) { $sMin = $MAE;}
    if ( $sMin > $RMSE ) { $sMin = $RMSE;}

    push(@YHOUR0,$yhour);
    push(@ME0,$ME);
    push(@MAE0,$MAE);
    push(@RMSE0,$RMSE);
  }
  close(IN);

  #----------------------------------------------
  my @data  = (\@YHOUR0,\@ME0,\@MAE0,\@RMSE0);
  #----------------------------------------------

  #----------------------------------------------
  # 
  #----------------------------------------------
  $xwidth= 600;
  $y1_label = "ERROR [%]";
  $x1_label = "[ Lead Time [h] ]"; 
  $title = sprintf("%s",$title);
  $y1_max=50;
  $y1_min=-10;
  $xlskip = 6;

 #-- ļβ
  $sMax = (int($sMax/10+1))*10;
  $sMin = (int($sMin/10-1))*10;

  if ( $y1_max < $sMax ) { $y1_max = $sMax;}
  if ( $y1_min > $sMin ) { $y1_min = $sMin;}

  $y_jiku_num = int(($y1_max - $y1_min)/10);


  my $graph = GD::Graph::mixed->new( $xwidth, 294 );
#  $graph->set_legend("ME(%)","MAE(%)","RMSE(%)");
  $graph->set_x_label_font(gdLargeFont);
  $graph->set_y_label_font(gdLargeFont);
  $graph->set_x_axis_font(gdLargeFont);
  $graph->set_y_axis_font(gdLargeFont);
   
  $graph->set(
       two_axes => 0,
       t_margin => 10,
       b_margin => 10,
       l_margin => 10,
       r_margin => 10,
       title   => "$title",
       y_label => "$y1_label",
       y_max_value => $y1_max,
       y_min_value => $y1_min,
       x_label => $x1_label,
       x_label_position => 1/2,
       types   => [ qw(linespoints linespoints linespoints) ],
       #types   => [ qw(lines lines) ],
       #types   => [ qw(linespoints linespoints) ],
       bgclr   => "white",
       fgclr   => "black",
       boxclr  => "white",
#       shadowclr => "DarkSlateGrey",
#       shadow_depth => 1,
       #dclrs => [ "myred" ],
       #dclrs => [ "myred", "IndianRed" ],
       #dclrs => [ "black","red","green","blue","orange","gray" ],
       dclrs => [ "lred","lblue","lgreen" ],
       #accentclr => "black",
       #accentclr => "myred",
       #line_width => [qw(2 1)],
       line_width => 2,
       line_types => [qw(1 1 1)],
       #bar_spacing => 1,
       x_label_skip => $xlskip,
#       x_tick_offset => 12,
#       y_tick_number => 6,
       y_tick_number => "$y_jiku_num",
       y_label_skip  => 1,
       long_ticks  => 1,
       skip_undef => 1,
       markers     => [ 1,5,7 ],
       marker_size => 3,
#       box_axis => true,
  );
  #----------------------------------------------

  #----------------------------------------------
  # PLOT
  #----------------------------------------------
  $gra = "";
#  printf "\n Plot data\n";
  $gra = $graph->plot(\@data);

  $fig = new GD::Image(600,294);
  $whilte = $fig->colorAllocate(255,255,255);
  $fig->fill(600,294,$whilte);
  $fig->copy($gra,0,0,0,0,600,294);
  $title_p = GD::Image->newFromPng("$title_parts");
  $hanrei_p = GD::Image->newFromPng("$hanrei_parts");
  #print "\n Plot fig $title_parts\n";
  $fig->copy($title_p,84,6,0,0,260,21);
  $fig->copy($hanrei_p,346,8,0,0,245,18);

open(IMG,">$ofile");
   binmode IMG;
   print IMG $fig->png;
close(IMG);


exit;
