#####################################################################
# mk_pic_real_std.pl
#
#####################################################################
use Time::Local;
use GD;
use GD::Graph::mixed;

$table = $ARGV[0];
$AREA_NUM = $ARGV[1];
$POINT_NUM = $ARGV[2];

require "$table";


  @DATE=();@DAT=();@FST=();@FST05=();@FST95=();@FST1sL=();@FST1sU=();
  #----------------------------------------------
  # Input / Output File Setting
  #----------------------------------------------
    $ifile = sprintf("%s",$CSVFile_Today);
    $ofile = sprintf("%s",$GrFile_Today);
    $title_parts = sprintf("%s/pic_parts/CNT111_title.png",$EXE_DIR);
    $hanrei_parts = sprintf("%s/pic_parts/hanrei_CNT111.png",$EXE_DIR);
    $title = "       ";
    #$title = " Today's Wind Power [%] ";
  $now_bar_parts = sprintf("%s/pic_parts/Now_bar.png",$EXE_DIR);

  print " <- $ifile\n";
  print " -> $ofile\n";

  #----------------------------------------------
  #  Read Inputfile
  #---------------------------------------------- 
  $OBS_NOW = "";
  open(IN,"<$ifile");
  $idt = 0;
  while(<IN>){
    chomp $_; 
     $idt++;
#    ($yDate,$obs_mw,$obs_p,$fst_mw,$fst_p) = split(/,/, $_);
    ($yDate,$obs_mw,$obs_p,$fst_mw,$fst_p,$fst_mw165,$fst_p165,$fst_mw835,$fst_p835,$fst_mw050,$fst_p050,$fst_mw950,$fst_p950) = split(/,/, $_);
    ($year_t,$mon_t,$day_time) = split(/\//,$yDate);
    ($day_t,$hhmm) = split(/\s+/,$day_time);
    #$date = sprintf("%02d/%s",$mon,$day_time);
    $date = sprintf("%s",$hhmm);
    if ( $obs_mw ne "" ) { 
       $OBS_NOW = $date;
       $year = $year_t; $mon=$mon_t; $day=$day_t;  
       undef $fst_mw165;
       undef $fst_p165;
       undef $fst_mw835;
       undef $fst_p835;
       undef $fst_mw050;
       undef $fst_p050;
       undef $fst_mw950;
       undef $fst_p950;
    }
    if (( $idt <= 12 ) or ($fst_mw eq "")) {    #-- β( $idt <= 12 ) , ͽ¬ͤʤ
       undef $fst_mw165;
       undef $fst_p165;
       undef $fst_mw835;
       undef $fst_p835;
       undef $fst_mw050;
       undef $fst_p050;
       undef $fst_mw950;
       undef $fst_p950;
    }
    if ( $obs_p eq "" or $obs_mw < -900 ) { undef $obs_p;}
    if ( $fst_p eq "" or $fst_mw < -900 ) { undef $fst_p;}
#    print "DAT=$date,$obs_p,$fst_p\n";
    push(@DATE,$date);
    push(@DAT,$obs_p);
    push(@FST,$fst_p);
    push(@FST05,$fst_p050);
    push(@FST95,$fst_p950);
    push(@FST1sL,$fst_p165);
    push(@FST1sU,$fst_p835);
  }
  close(IN);

  #----------------------------------------------
  #  Set New Observation Time
  #----------------------------------------------
  ($hh,$mm) = split(/:/,$OBS_NOW);
  $OBS_NOW = sprintf("%02d%02d",$hh,$mm);
  #print "NOW_XP = $NOW_XP{$OBS_NOW}\n";
 
  #----------------------------------------------
  my @data  = (\@DATE,\@DAT,\@FST,\@FST05,\@FST95,\@FST1sL,\@FST1sU);
  #----------------------------------------------

  #----------------------------------------------
  # 
  #----------------------------------------------
  $xwidth= 600;
  $y1_label = "Wind Power [%]";
#  $x1_label = sprintf("[ DATE %04d/%02d/%02d ]",$year,$mon,$day); 
  $x1_label = "[ FORECAST 24h ]"; 
  $title = sprintf("%s",$title);
  $y1_max=100;
  $y1_min=0;
  $xlskip = 12;

  my $graph = GD::Graph::mixed->new( $xwidth, 294 );
#  $graph->set_legend("Observation(%)","Forecast(%)");
  $graph->set_x_label_font(gdLargeFont);
  $graph->set_y_label_font(gdLargeFont);
  $graph->set_x_axis_font(gdLargeFont);
  $graph->set_y_axis_font(gdLargeFont);
   
  $graph->set(
       two_axes => 0,
       t_margin => 10,
       b_margin => 10,
       l_margin => 10,
       r_margin => 10,
       title   => "$title",
       y_label => "$y1_label",
       y_max_value => $y1_max,
       y_min_value => $y1_min,
       x_label => $x1_label,
       x_label_position => 1/2,
       #types   => [ qw(linespoints linespoints ) ],
       ###types   => [ qw(lines lines lines lines) ],
       types   => [ qw(lines lines lines lines lines lines) ],
       #types   => [ qw(linespoints linespoints) ],
       bgclr   => "white",
       fgclr   => "black",
       boxclr  => "white",
#       shadowclr => "DarkSlateGrey",
#       shadow_depth => 1,
       #dclrs => [ "myred" ],
       #dclrs => [ "myred", "IndianRed" ],
       #dclrs => [ "black","red","green","blue","orange","gray" ],
       #dclrs => [ "lblue","lred" ],
       ###dclrs => [ "lblue","lred","green","green" ],
       dclrs => [ "lblue","lred","green","green","orange","orange" ],
       #accentclr => "black",
       #accentclr => "myred",
       #line_width => [qw(2 1)],
       line_width => 2,
       ###line_types => [qw(1 1 3 3)],
       line_types => [qw(1 1 3 3 3 3)],
       #bar_spacing => 1,
       x_label_skip => $xlskip,
       x_tick_offset => 12,
       y_tick_number => 5,
       y_label_skip  => 1,
       long_ticks  => 1,
       skip_undef => 1,
#       markers     => [ 5 ],
#       marker_size => 1,
  );
  #----------------------------------------------

  #----------------------------------------------
  # PLOT
  #----------------------------------------------
  $gra = "";
  printf "\n Plot data\n";
  $gra = $graph->plot(\@data);

  $fig = new GD::Image(600,294); 
  $whilte = $fig->colorAllocate(255,255,255);
  $fig->fill(600,294,$whilte);
  $fig->copy($gra,0,0,0,0,600,294);
  $title_p = GD::Image->newFromPng("$title_parts"); 
  $hanrei_p = GD::Image->newFromPng("$hanrei_parts"); 
  #---
    $now_bar_p = GD::Image->newFromPng("$now_bar_parts"); 
    $fig->copy($now_bar_p,167,31,0,0,3,212);  
  #-- ǿ¶ΥС
  ##$fig->copy($title_p,129,6,0,0,260,21);
  $fig->copy($title_p,55,6,0,0,260,21);
  ##$fig->copy($hanrei_p,390,5,0,0,201,22);
  $fig->copy($hanrei_p,290,5,0,0,300,22);

  open(IMG,">$ofile");
   binmode IMG;
   print IMG $fig->png;
  close(IMG);


exit;
