#!/usr/local/bin/perl
#####################################################################
# mk_realfst.pl
#
#  Υǡ
#  Useage ./mk_realfst_std.pl  TABLE_FILE -t YYMMDDHHmm\n YYMMDDHHmm:JST
#  -t ץǻ򤷤ʤϡǿǽ
#
#####################################################################
require "./platform_lib.pl";

#$TABLE = $ARGV[0];
#require "./$TABLE";

use Getopt::Long;
use Time::Local;
$Getopt::Long::ignorecase=undef;
GetOptions('h=s','t=s','f=s','o=s','a=s','w=s','p=s','m=s');

$POWER_MAX = 1;
$NHOUR     = $opt_h;
$FST_DIR   = $opt_f;
$OBS_DIR   = $opt_o;
$MODL_NUM  = $opt_m;
$AREA_NUM  = $opt_a;
$POINT_NUM = $opt_w;
$POWER_MAX = $opt_p;

$REAL_DSET_File = "./data/DSET_${MODL_NUM}_${AREA_NUM}_${POINT_NUM}.out";;

#######    ###################
$msg_usage = "Usage ./mk_realfst_std.pl -f Forecast_PATH -o OBS_PATH -a Area_code -w WF_code -t YYMMDDHHmm\n";
if( $opt_t ne "" && length($opt_t)!=10 ){
    die "$msg_usage";
}elsif( length( $opt_t ) == 10 ){
    $jyear4=1*substr($opt_t,0,2)+2000;
    $jyear2=1*substr($opt_t,0,2);
    $jmonth =1*substr($opt_t,2,2);
    $jday =1*substr($opt_t,4,2);
    $jhour=1*substr($opt_t,6,2);
    $jmin=1*substr($opt_t,8,2);
}else{
    $jst = time();
    ($jsec,$jmin,$jhour,$jday,$jmonth,$jyear)=localtime( $jst );
    $jyear4=$jyear+1900; $jyear2=$jyear4%100; $jmonth++;
}
if( $opt_h eq "" || $opt_f eq "" || $opt_o eq "" || $opt_a eq "" || $opt_w eq "" ){
    print  "$msg_usage\n";
    die "Please specify option";
}

$y2mdhm = sprintf("%02d%02d%02d%02d%02d",$jyear2,$jmonth,$jday,$jhour,$jmin);
$y4mdhm = sprintf("%04d%02d%02d%02d%02d",$jyear4,$jmonth,$jday,$jhour,$jmin);
print "Y4MDHM=$y4mdhm,$y2mdhm\n";

($n_ymdhm,$n_ymdhm1) = ctrl_time($y2mdhm);
print "001 : $n_ymdhm,$n_ymdhm1\n";
#$n_ymdhm = "0709071200";

($y4mdhm_m1) = ctrl_time_mday($y4mdhm,1);  #1
($y4mdhm_p1) = ctrl_time_pday($y4mdhm,2);  #1
($y4mdhm_p2) = ctrl_time_pday($y4mdhm,0);  #2
$y4md = substr("$y4mdhm",0,8);
$y4md_m1 = substr("$y4mdhm_m1",0,8);
$y4md_p1 = substr("$y4mdhm_p1",0,8);
$y4md_p2 = substr("$y4mdhm_p2",0,8);
$y2md = substr("$y4mdhm",2,6);
$y2md_m1 = substr("$y4mdhm_m1",2,6);
$y2md_p1 = substr("$y4mdhm_p1",2,6);
$y2md_p2 = substr("$y4mdhm_p2",2,6);

$o_dir_ym = substr("$y4mdhm",2,4);
$o_dir_ym_m1 = substr("$y4mdhm_m1",2,4);

print "## $y4mdhm_m1\n";
print "## $y4mdhm_p2\n";

#### ʽϳǧ ########################
if ( $POWER_MAX <= 0) { exit; }
##########################################

################################
##   open output file         ##
################################
open(OUT,">$REAL_DSET_File");
print "OUT=$REAL_DSET_File\n";

###########################################
#---  Observation + forecast File     --- #
###########################################
$MNEW_FLG = 0;
$nback = $NHOUR*2;
foreach  $backtime ( 1..$nback ) {
  $y4mdhm = ctrl_time_mday($y4mdhm,1/48);  # 30min before
  ($y4md_date,$hh,$min) = $y4mdhm =~ /(\S\S\S\S\S\S\S\S)(\S\S)(\S\S)/;

      $obsf = sprintf("%ss%s_%08d%02d%02d.csv",$AREA_NUM,$POINT_NUM,$y4md_date,$hh,$min);

      $obs_ym = substr("$obsf",9,4);
      $obs_ymd = substr("$obsf",9,6); 
      $obs_ymdhm = substr("$obsf",9,10); 
      $hh = sprintf("%02d",$hh);
      #$min = sprintf("%02d",$min);

      $obs_yy2 = substr("$obsf",9,2);
      $obs_mm = substr("$obsf",11,2);
      $obs_dd = substr("$obsf",13,2);

      if ( $n_ymdhm <= $obs_ymdhm ) {
        $MNEW_FLG = 1;
        last;
      }

      $OFile = sprintf("%s/c%s/%s",$OBS_DIR,$obs_ym,$obsf);
       print "OFile = $OFile\n";
      unless ( -e $OFile ) {
        printf OUT ("%02d,%02d,%02d,%02d,%02d,,,,,,,,,,,,\n",$obs_yy2,$obs_mm,$obs_dd,$hh,$min);
        next;
      }
      
      @dummy=(); 
      open(IN1,"<$OFile");
        @dummy = <IN1>;
      close(IN1);

      foreach $obs_line (@dummy) {
        @buf_o=();
        chomp($obs_line);
        next if ($obs_line =~ /^#/);
        @buf_o = split(/,/,"$obs_line");
        $buf_o[5] = 1*$buf_o[5];  #--kW
        $buf_o[6] = 1*$buf_o[6];  #--%
#        print "#####0 buf_o[5]=$buf_o[5]\n";
        if ( $buf_o[5] < 0 and $buf_o[5] > -900) { 
          $buf_o[5] = "0.00";
          $P_efficiency_obs = "0.00";
        } elsif ( $buf_o[5] <= -900 ) {
          $buf_o[5] = "";
          $P_efficiency_obs = "";
        } else {
          $buf_o[5] = sprintf("%.2f",$buf_o[5]/1000.);
          #$P_efficiency_obs = sprintf("%.2f",($buf_o[5]/$POWER_MAX)*100);
          $P_efficiency_obs = sprintf("%.2f",$buf_o[6]);
        } 
#        print "#####1  buf_o[5]=$buf_o[5]\n";

        #--- ¬Ʊͽ¬ǡ
        $fcs_flg = 0;
        #--- ¶24ͽ¬ǡ¶ͽ¬ͤ롣
        $obs_YY=1*substr($obs_ymdhm,0,2)+2000;
        $obs_MM=1*substr($obs_ymdhm,2,2);
        $obs_DD=1*substr($obs_ymdhm,4,2);
        $obs_HH=1*substr($obs_ymdhm,6,2);
        $obs_MN=1*substr($obs_ymdhm,8,2);
        $obs_time_m3 = timelocal(0,$obs_MN,$obs_HH,$obs_DD,$obs_MM-1,$obs_YY);
        #--- ¬24ͽ¬ǡ
        ($sec_f,$min_f,$hour_f,$mday_f,$mon_f,$year_f,$wday_f,$yday_f,$isdist_f) = localtime($obs_time_m3-24*3600);
        #($sec_f,$min_f,$hour_f,$mday_f,$mon_f,$year_f,$wday_f,$yday_f,$isdist_f) = localtime($obs_time_m3-12*3600);
        $mon_f++;
        $year_f4 = $year_f+1900;
        $year_f2 = $year_f4 % 100;
        $obs_ymdhm_m3 = sprintf("%02d%02d%02d%02d%02d",$year_f2,$mon_f,$mday_f,$hour_f,$min_f);

        ($fsc_ymdhm,$fsc_ymdhm1) = ctrl_time_d($obs_ymdhm_m3);
        print "fsc_ymdhm=$fsc_ymdhm, obs_ymdhm=$obs_ymdhm,obs_ymdhm_m3=$obs_ymdhm_m3\n";

        #$fcs_dir_ym = substr("$fsc_ymdhm",0,4);
        $fcs_dir_ym = substr("$obs_ymdhm_m3",0,4);
        $fcs_dir = sprintf("%s/c%s",$FST_DIR,$fcs_dir_ym);
        $FFile = sprintf("%s/%sf%s_20%s.csv",$fcs_dir,$AREA_NUM,$POINT_NUM,$obs_ymdhm_m3);
        print "FFile = $FFile\n";
#---   2008.02.19add
        unless ( -e $FFile ) {
           $of_date = sprintf("%02d,%02d,%02d,%02d,%02d",$obs_yy2,$obs_mm,$obs_dd,$hh,$min);
           print OUT "$of_date,$buf_o[5],$P_efficiency_obs,,,,,,,,,,\n";
           next;  
        }
           
        open(FF,"<$FFile");
        for($i=0;$i<10;$i++) {
           $dumy=<FF>;
        }
        while(<FF>){
          @buf_f = ();
          chomp($_);
          @buf_f = split(/,/,"$_");
          $buf_f[5] = $buf_f[5]*1;
          print "$buf_f[0],$buf_f[1],$buf_f[2],$buf_f[3],$buf_f[4],$buf_f[5]\n"; 
          $buf_f0_yy = substr("$buf_f[0]",2,2);
          $date_time = sprintf("%02d%02d%02d%02d%02d",$buf_f0_yy,$buf_f[1],$buf_f[2],$buf_f[3],$buf_f[4]);
          if ( $date_time ne $obs_ymdhm ) { 
              next; 
          } else {
            $fcs_flg = 1;
            for($k=5;$k<=9;$k++){
              $buf_f[$k] = sprintf("%.2f",1*$buf_f[$k]);
              if ( $buf_f[$k] < 0 and $buf_f[$k] > -90000) {
                $buf_f[$k] = "0.00";
                $P_efficiency_fcs[$k] = "0.00"; 
              } elsif ( $buf_f[$k] <= -90000 ) {
                $buf_f[$k] = "";
                $P_efficiency_fcs[$k] = "";
              } else {
                $buf_f[$k] = sprintf("%.2f",$buf_f[$k]/1000.0);
                $P_efficiency_fcs[$k] = sprintf("%.2f",($buf_f[$k]/$POWER_MAX)*100);
              }
            } #for
            last;
          }
        } #while(<FF>)
        close(FF);
  
        #-- ¬͡ͽ¬ͤν
        $of_date = sprintf("%02d,%02d,%02d,%02d,%02d",$obs_yy2,$obs_mm,$obs_dd,$hh,$min);
        if ( $fcs_flg == 1 ) {
           print OUT "$of_date,$buf_o[5],$P_efficiency_obs,$buf_f[5],$P_efficiency_fcs[5],$buf_f[6],$P_efficiency_fcs[6],$buf_f[7],$P_efficiency_fcs[7],$buf_f[8],$P_efficiency_fcs[8],$buf_f[9],$P_efficiency_fcs[9]\n";
        } else {
           print OUT "$of_date,$buf_o[5],$P_efficiency_obs,,,,,,,,,,\n";
        }

      } #foreach $obs_line (@dummy)

    #} #foreach $min ( 00,30 ) {

    if ( $MNEW_FLG == 1 ) {
      last;
    }

  if ( $MNEW_FLG == 1 ) {
     last;
  }

} #foreach $bhour

close(OUT);
exit;

