#!/usr/bin/perl
#==============================
# Nedo Platform Library. 
#------------------------------
#===================================================== 
#       S U B   F U N C T I O N
#=====================================================
## ------------------------
# Write TABLE Part.
## ------------------------
sub Write_TABLE100_WF {
#--- csv => html
  my ($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$DAT_PATH) = @_;
  my ( @line0,@dat );

  my $INFILE = sprintf("%s/cnt%s_a%s_p%s.csv",$DAT_PATH,$CNT_NUM,$AREA_NUM,$WF_NUM);

  open(INsub1,"<$INFILE");
  @line0 = <INsub1>;
  close(INsub1);

  print "<table>\n";
  print "<col width=\"120\"><col width=\"70\"><col width=\"70\"><col width=\"70\"><col width=\"70\">\n";
  print "<tr bgcolor=\"\#c0c0c0\"><td></td><td>¬[MW]</td><td>¬[%]</td><td>ͽ¬[MW]</td><td>ͽ¬[%]</td></tr>\n";

  foreach my $line ( @line0 ) {
    chomp($line);
    @dat = split(/,/,$line);
    if ( $dat[1] eq "" ) { 
       $dat[1] = "-"; 
    } else {
#       $dat[1] = "*";
    } 
    if ( $dat[2] eq "" ) { $dat[2] = "-"; }
    if ( $dat[3] eq "" ) { 
       $dat[3] = "-"; 
    } else {
#       $dat[3] = "*"; 
    }
    if ( $dat[4] eq "" ) { $dat[4] = "-"; }
    print "<tr><td>$dat[0]</td><td>$dat[1]</td><td>$dat[2]</td><td>$dat[3]</td><td>$dat[4]</td></tr>\n";
  }
  print "</table>\n";

}

sub Write_TABLE200_WF {
#--- csv => html
  my ($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$DAT_PATH) = @_;
  my ( @line0,@dat );

  my $INFILE = sprintf("%s/cnt%s_a%s_p%s.csv",$DAT_PATH,$CNT_NUM,$AREA_NUM,$WF_NUM);

  open(INsub2,"<$INFILE");
  @line0 = <INsub2>;
  close(INsub2);

  print "<table>\n";
  print "<col width=\"120\"><col width=\"70\"><col width=\"70\"><col width=\"70\">\n";
  print "<tr bgcolor=\"\#c0c0c0\"><td>ͽ¬</td><td>ME[%]</td><td>MAE[%]</td><td>RMSE[%]</td></tr>\n";

  foreach my $line ( @line0 ) {
    chomp($line);
    @dat=();
    @dat = split(/,/,$line);
    my $hh = int($dat[0]);
    my $mm = sprintf("%02d",($dat[0]-$hh)*60);
    my $ytime = sprintf("%02d:%02d",$hh,$mm);
    if ( $dat[1] ne "" ) { 
       $dat[1] = sprintf("%.2f",$dat[1]);
    } else {
       $dat[1] = "-";
    }
    if ( $dat[2] ne "" ) { 
       $dat[2] = sprintf("%.2f",$dat[2]);
    } else {
       $dat[2] = "-";
    }
    if (( $dat[3] ne "" ) and ( $dat[3] >= 0.01)) {
       $dat[3] = sprintf("%.2f",$dat[3]);
    } else {
       $dat[3] = "-";
    }
    print "<tr><td>$ytime</td><td>$dat[1]</td><td>$dat[2]</td><td>$dat[3]</td></tr>\n";
  }
  print "</table>\n";

}

## ------------------------
# Write Contents Part.
## ------------------------
sub Write_Content_WF {
   my ($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$DAT_PATH,$S_FLG) = @_;
   my ($tblf,$line,$fig,$line);
   
   $tblf = sprintf("wf_cnt_%s.tab",$CNT_NUM);
   open(INsub0,"<$tblf");
   while ($line = <INsub0>) {

     if ( $line =~ /##WF_NAME_NEDO##/ ) {
       $WF_NAME = &WF_NAME_SET($AREA_NUM,$WF_NUM,$WF_POINT_TAB);
       $line =~ s/##WF_NAME_NEDO##/$WF_NAME/g;
       print "$line";
     } elsif (( $line =~ /#WF_NUM#/ ) or( $line =~ /#AW_CODE#/ ) or ( $line =~ /#AREA_NUM#/ ) or ( $line =~ /#S_FLG#/ )){
       $line =~ s/#AW_CODE#/$AW_CODE/g;
       $line =~ s/#AREA_NUM#/$AREA_NUM/g;
       $line =~ s/#WF_NUM#/$WF_NUM/g;
       $line =~ s/#S_FLG#/$S_FLG/g;
       print "$line"; 
     } elsif ( $line =~ /##MAIN_GRAPH_PNG##/ ) {
        $fig = sprintf("%s/gr%s_a%s_p%s.png",$DAT_PATH,$CNT_NUM,$AREA_NUM,$WF_NUM);
        $line =~ s/##MAIN_GRAPH_PNG##/$fig/g;
        print "$line";
     } elsif ( $line =~ /##MAIN_TABLE100_csv##/ ) {
        Write_TABLE100_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$DAT_PATH);
     } elsif ( $line =~ /##MAIN_TABLE200_csv##/ ) {
        Write_TABLE200_WF($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$DAT_PATH);
     } elsif ( $line =~ /##SHUUDAN_START##/ ) {
        my $shuudan_t = Write_SHUUDAN_START();
        $line =~ s/##SHUUDAN_START##/$shuudan_t/g;
        print "$line";
     } else {
        print "$line";
     }
   }
   close(INsub0);

}

## ------------------------
# Write Contents Part.
## ------------------------
sub Write_Content501_WF {
   my ($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$DAT_PATH,$S_FLG) = @_;
   my ($ip,$gtbl,$tblf,$line,$fig,$gaib,$gnum);
   my @g_sys;

   $gtbl = "SHUUDAN_SYS.tab";
   open(INsub2,"<$gtbl");
     @g_sys = <INsub2>;
   close(INsub2);

   $gnum = 0;
   foreach $gaib ( @g_sys ) {
     chomp($gaib);
     if ( $gaib =~ /^#/ ) { next; }
     if ( $gaib =~ /,/ ) { $gnum++; }
   }  
    
   if ( $gnum == 0 ) { 
      $tblf = sprintf("wf_cnt_%s_Nshuudan.tab",$CNT_NUM); 
   } else {
      $tblf = sprintf("wf_cnt_%s.tab",$CNT_NUM);
   }
   open(INsub1,"<$tblf");
   while ($line = <INsub1>) {

     if (( $line =~ /#WF_NUM#/ ) or( $line =~ /#AW_CODE#/ ) or ( $line =~ /#AREA_NUM#/ ) or ( $line =~ /#S_FLG#/ )){
       $line =~ s/#AW_CODE#/$AW_CODE/g;
       $line =~ s/#AREA_NUM#/$AREA_NUM/g;
       $line =~ s/#WF_NUM#/$WF_NUM/g;
       $line =~ s/#S_FLG#/$S_FLG/g;
       print "$line";
     } elsif ( $line =~ /##GAIBU_SYSTEM_TORIKOMI##/ ) {
         $ip = 0;
         foreach $gaib ( @g_sys ) {
           @buf = ();
           chomp($gaib);
           if ( $gaib =~ /^#/ ) { next; }
           @buf = split(/,/,$gaib);
           if ( $ip == 0 ) {
             $gaib = sprintf("<tr><td><input type=\"checkbox\" name=\"gsystem\" value=\"$buf[1]\" checked>$buf[2]<\/td><\/tr>");
           } else {
             $gaib = sprintf("<tr><td><input type=\"checkbox\" name=\"gsystem\" value=\"$buf[1]\">$buf[2]<\/td><\/tr>");
           }
           print "$gaib\n";
           $ip++;
         } #foreach
     } else {
        print "$line";
     }
   }
   close(INsub1);

}
## ------------------------
# Write selected  Wind Farm.
## ------------------------

sub Write_Select_WF {

   my ($AW_CODE,$AREA_NUM,$WF_NUM,$CNT_NUM,$WF_POINT_TAB,$S_FLG) = @_;
   my ($line);
   my (@dat);
   my (%AorW,%areacode,%pcode,%pname);

   open(TAB,"<$WF_POINT_TAB");
   while($line=<TAB>) {
	next if ($line =~ /^#/);
   	chomp($line);
   	@dat = split(/,/,$line);
        $AorW{$dat[0]} = $dat[1];
        $areacode{$dat[0]} = $dat[2];
	$pcode{$dat[0]} = $dat[3];
	$pname{$dat[0]} = $dat[4];
   }
   close(TAB);

   ####
   if ( $AREA_NUM == 9999 or $WF_NUM == 9999 ) {
      foreach my $key (sort keys %AorW) {
         if ( $AorW{$key} eq $AW_CODE ) {  
           $line = sprintf("<option value=wf.cgi?AW=%s&AREA=%s&WF=%s&CNT=111&SFL=0>%s</option>",$AorW{$key},$areacode{$key},$pcode{$key},$pname{$key});
           print "$line\n";
         } else {
           next;
         }
      }

   } else {

      foreach my $key (sort keys %pcode) {
         if (($AW_CODE eq $AorW{$key} ) and ( $pcode{$key} eq $WF_NUM) and ($areacode{$key} eq $AREA_NUM)) {
           $line = sprintf("<option selected value=wf.cgi?AW=%s&AREA=%s&WF=%s&CNT=%s&SFL=%s>%s</option>",$AorW{$key},$areacode{$key},$pcode{$key},$CNT_NUM,$S_FLG,$pname{$key});
           print "$line\n";
         } elsif ($AW_CODE eq $AorW{$key} ) {
           $line = sprintf("<option value=wf.cgi?AW=%s&AREA=%s&WF=%s&CNT=%s&SFL=%s>%s</option>",$AorW{$key},$areacode{$key},$pcode{$key},$CNT_NUM,$S_FLG,$pname{$key});
           print "$line\n";
         } else {
         }
      }
   }

}  # end Write_Select_WF

#------------------------------------------
#   SET WF_NAME
#------------------------------------------

sub WF_NAME_SET {

   my ($AREA_NUM,$WF_NUM,$WF_POINT_TAB) = @_;
   my ($line);
   my (@dat);
   my ($pname);

#   my $WF_POINT_TAB = "WF_POINT.tab";

   if ( $WF_NUM eq "") { return;}

   open(TAB,"<$WF_POINT_TAB");
   while($line=<TAB>) {
        next if ($line =~ /^#/);
        chomp($line);
        @dat = split(/,/,$line);
        if (( $dat[2] eq $AREA_NUM ) and ( $dat[3] eq $WF_NUM )) {
          $pname = $dat[4];
          last;
        } 
   }
   close(TAB);

   return( $pname );

}

#------------------------------------------
#   SET SHUUDAN FLAG
#------------------------------------------
sub CHK_SHUUDAN_F {
  my ($FLG_File) = @_;
  my ( @dat,@dat2 );
  my ( $line,$i,$FLG );

  $FLG = 0;
  if ( -e $FLG_File ) {
    open(INshu,"<$FLG_F");
      @dat = <INshu>;
    close(INshu);
    $i = 0;
    foreach $line ( @dat ) {
       chomp( $line );
       if ( $i == 0 ) { 
         $FLG = $line;
         $i++;
         next;
       } else {
         @dat2 = $line;
       }
    }
    return($FLG);
  } else {
    return(0);
  }

}

#------------------------------------------
#   SET SERVER TIME 
#------------------------------------------
sub Write_SHUUDAN_START {
  my ( $jsec,$jmin,$jhh,$jdd,$jmm,$jyy,$jyy4,$jst);

  $jst = time;
  ($jsec,$jmin,$jhh,$jdd,$jmm,$jyy)=localtime( $jst );
    $jyy4=$jyy+1900; $jyy=$jyy4%100; $jmm++;

  my $set_time = sprintf("%04d-%02d-%02d %02d:%02d",$jyy4,$jmm,$jdd,$jhh,$jmin);
  return($set_time); 

}

1;
